# -*- coding: utf-8 -*-

"""
    ©2019 Ingram Micro Inc. all Rights Reserved
"""

from poaupdater import uLogging, uSysDB
from poaupdater.openapi import OpenAPI, OpenAPIError

openapi = OpenAPI()


def isPBAInstalled():
    try:
        pbaNodeId = openapi.pem.getSystemProperty(account_id=1, name='pba.app.host.node.id')['str_value']
        if not pbaNodeId:
            return False

        con = uSysDB.connect()
        cur = con.cursor()
        cur.execute("SELECT count(*) FROM hosts where host_id = %s" % pbaNodeId)
        [count] = cur.fetchone()
        return count > 0
    except OpenAPIError:
        return False


def getVendorCompany(account_id):
    try:
        account = openapi.pem.getAccountInfo(account_id=account_id)
    except Exception as e:
        uLogging.warn("Unable to retrieve information about the customer '%s': %s" % (account_id, str(e)))
        return None

    return account['person']['company_name']
