# -*- coding: utf-8 -*-

"""
    ©2017 Ingram Micro Inc. all Rights Reserved
"""

from pba import getBMVersionList, BMVersion


class VersionManager:
    def __init__(self, replaceCurrentVersionBy=None):
        self.versions = getBMVersionList()
        self.replaceCurrentVersionBy = None

        if replaceCurrentVersionBy:
            self.replaceCurrentVersionBy = BMVersion(
                productVersion='-'.split(replaceCurrentVersionBy)[0],
                buildVersion=replaceCurrentVersionBy,
                installDate=None
            )

    def getVersions(self):
        return self.versions

    def getVersionForDate(self, date):
        foundVersion = self.versions[0]

        for version in self.versions:
            if version.installDate <= date:
                foundVersion = version
                continue
            return foundVersion
        return foundVersion

    def getCurrentVersion(self):
        return self.replaceCurrentVersionBy or self.versions[-1]
