<!-- cookie_warning.tpl -->

{* Backend path where need to update constants on changes: templatestore/src/Service/Session/Session.php *}
<script language="JavaScript">
    // CAUTION!!! These cookie settings are used in backend. DO NOT CHANGE or update in backend too.
    let ALLOW_COOKIES_COOKIE_NAME = "ALLOW_COOKIES";
    let ALLOW_COOKIES_COOKIE_VALUE_ALLOWED = "true";
    let ALLOW_COOKIES_COOKIE_VALUE_DECLINED = "false";
    let ALLOW_COOKIES_COOKIE_EXP_PERIOD_DAYS = 90;

    function createCookie(name,value,days) {
        let date = new Date();
        let expires;
        if (days) {
            date.setTime(date.getTime()+(days*60*60*24*1000));
            expires = "; expires="+date.toGMTString();
        } else {
            expires = "";
        }
        document.cookie = name+"="+value+expires+"; path=/";
    }

    function readCookie(name) {
        let nameEQ = name + "=";
        let cookies = document.cookie.split(';');
        for (let i=0; i < cookies.length; i++) {
            let cookie = cookies[i].trim();
            if (cookie.indexOf(nameEQ) === 0) return cookie.substring(nameEQ.length,cookie.length);
        }
        return null;
    }

    function allowCookies(value) {
        createCookie(ALLOW_COOKIES_COOKIE_NAME,value,ALLOW_COOKIES_COOKIE_EXP_PERIOD_DAYS);
        document.location.reload(true);
    }

    document.addEventListener("DOMContentLoaded", function(){
        if (readCookie(ALLOW_COOKIES_COOKIE_NAME) == ALLOW_COOKIES_COOKIE_VALUE_ALLOWED) {
            console.log("Cookies was accepted by customer.");
            document.getElementById('gdpr-cookie-banner').style.display = 'none';
        } else if (readCookie(ALLOW_COOKIES_COOKIE_NAME) == ALLOW_COOKIES_COOKIE_VALUE_DECLINED) {
            console.log("Cookies was declined by customer.");
            document.getElementById('gdpr-cookie-banner').style.display = 'none';
        } else {
            console.log("Cookie policy is not accepted yet.");
            document.getElementById('gdpr-cookie-banner').style.display = 'block';
        }
    });
</script>

<div id='gdpr-cookie-banner'>
    <p>{$smarty.session.LANG.GDPR_COOKIE_BANNER_MESSAGE_TEXT}</p>
    <button onclick="allowCookies(ALLOW_COOKIES_COOKIE_VALUE_DECLINED);" class='btn-decline-cookies'>
        {$smarty.session.LANG.GDPR_COOKIE_BANNER_BTN_DECLINE_TEXT}
    </button>
    <button onclick="allowCookies(ALLOW_COOKIES_COOKIE_VALUE_ALLOWED);" class='btn-allow-cookies'>
        {$smarty.session.LANG.GDPR_COOKIE_BANNER_BTN_ACCEPT_TEXT}
    </button>
</div>

<!-- end of cookie_warning.tpl -->