<!--
  payment_status.tpl
-->
  {if !$printLayout && ($needRedirect || $needOpenModalForm)}

  <table class="tableHeader" cellspacing="0" cellpadding="0">
    <tr>
      <td class="tableHeaderTD"><span class="BlockName">{msg what='CONFIRMATION_PAYMENT_STATUS_SECTION'}</span></td>
    </tr>
  </table>

  <script type="text/javascript">

    const PAYMENTSTATUS_INPROGRESS = '1';
    const PAYMENTSTATUS_WAIT = '2';
    const PAYMENTSTATUS_COMPLETE = '3';
    const PAYMENTSTATUS_FAILED = '4';
    const PAYMENTSTATUS_WAIT_MODAL = '5';
    const PAYMENTSTATUS_3DSECURE = '6';

    var docID = {$smarty.session.OrderInfo.DocID};

    function clickPayNow() {
      {if $needRedirect}
      window.open('?view=externalpay&DocID='+docID,'_blank');
      {/if}
      {if $needOpenModalForm}
      execCheckoutHandler();
      {/if}
    }

    function applyVisibilityTo(elements, visible) {
      var display = visible ? '' : 'none';
      for(var i = 0; i < elements.length; i++) {
        elements[i].style.display = display;
      }
    }

    function updateVisibilityForClass(statusClass, statusDependentVisible) {
      applyVisibilityTo( document.getElementsByClassName("status-dependent-element"), statusDependentVisible);
      applyVisibilityTo( document.getElementsByClassName("status-row"), false );
      applyVisibilityTo( document.getElementsByClassName(statusClass), true );
    }

    function refreshPaymentStatus(status) {
      switch (status) {
      case PAYMENTSTATUS_INPROGRESS:
        updateVisibilityForClass("status-inprogress", true);
        break;

      case PAYMENTSTATUS_WAIT:
      case PAYMENTSTATUS_WAIT_MODAL:
        updateVisibilityForClass("status-wait", true);
        break;

      case PAYMENTSTATUS_3DSECURE:
         updateVisibilityForClass("status-3dsecure", true);
       break;

      case PAYMENTSTATUS_COMPLETE:
        updateVisibilityForClass("status-completed", false);
        break;

      case PAYMENTSTATUS_FAILED:
        updateVisibilityForClass("status-failed", true);
        break;

      default:
      };
    }

    function updatePaymentStatus(statusData) {
      try {
        var response = JSON.parse(statusData);
        var status   = response.status;
        if (status != PAYMENTSTATUS_COMPLETE ) {
          setTimeout( fetchPaymentStatus, 3000 );
        }
        refreshPaymentStatus(status);
      } catch (e) {
      }
    }

    function fetchPaymentStatus() {
        SW.Async.sendXMLHttpRequest('?info=paymentstatus&DocID=' + docID, updatePaymentStatus);
    }

    SW.Signal.addLoadEvent(function() {
      fetchPaymentStatus();
    });
  </script>

  <table class="tableContent tableSMContent" cellpadding="0" cellspacing="0" id="StatusData" name="StatusData">
  <tr>
    <td class="tableContentTD tableSMContentTD" valign="top">
      <table cellpadding="0" cellspacing="0" style="width: 100%;">
        <tr class="status-row status-inprogress" style="display:none;">
          <td style="width: 15%;"><label><b>{$smarty.session.LANG.CONFIRMATION_PAYMENT_STATUS}</b></label></td>
          <td align="left" style="width: 16px;"><img src="{$SCRIPT_DIR}/static/design/images/icons/state-yellow.gif"/></td>
          <td align="left">&nbsp;{$smarty.session.LANG.CONFIRMATION_PAYMENT_STATUS_PROCESSING}</td>
        </tr>
        <tr class="status-row status-wait" id="status-wait" style="display:none;">
          <td style="width: 15%;"><label><b>{$smarty.session.LANG.CONFIRMATION_PAYMENT_STATUS}</b></label></td>
          <td align="left" style="width: 16px;"><img src="{$SCRIPT_DIR}/static/design/images/icons/state-yellow.gif"/></td>
          {if $needRedirect}
          <td align="left">&nbsp;{$smarty.session.LANG.CONFIRMATION_PAYMENT_STATUS_WAIT}</td>
          {else}
          <td align="left">&nbsp;{$smarty.session.LANG.CONFIRMATION_PAYMENT_STATUS_WAIT_MODAL}</td>
          {/if}
        </tr>
        <tr class="status-row status-3dsecure" id="status-3dsecure" style="display:none;">
          <td style="width: 15%;"><label><b>{$smarty.session.LANG.CONFIRMATION_PAYMENT_STATUS}</b></label></td>
          <td align="left" style="width: 16px;"><img src="{$SCRIPT_DIR}/static/design/images/icons/state-yellow.gif"/></td>
          <td align="left">&nbsp;{$smarty.session.LANG.CONFIRMATION_PAYMENT_STATUS_3DSECURE}</td>
        </tr>
        <tr class="status-row status-failed" style="display:none;">
          <td style="width: 15%;"><label><b>{$smarty.session.LANG.CONFIRMATION_PAYMENT_STATUS}</b></label></td>
          <td align="left" style="width: 16px;"><img src="{$SCRIPT_DIR}/static/design/images/icons/state-red.gif"/></td>
          <td align="left">&nbsp;{$smarty.session.LANG.CONFIRMATION_PAYMENT_STATUS_FAILED}</td>
        </tr>
        <tr class="status-row status-completed" style="display:none;">
          <td style="width: 15%;"><label><b>{$smarty.session.LANG.CONFIRMATION_PAYMENT_STATUS}</b></label></td>
          <td align="left" style="width: 16px;"><img src="{$SCRIPT_DIR}/static/design/images/icons/state-green.gif"/></td>
          <td align="left">&nbsp;{$smarty.session.LANG.CONFIRMATION_PAYMENT_STATUS_COMPLETED}</td>
        </tr>
      </table>
    </td>
  </tr>

  <tr>
  </tr>

  <tr class="status-dependent-element">
    <td class="tableContentTD tableSMContentTD" valign="top">
      <label class="status-inprogress status-wait status-row" style="display:none;"><b>{$smarty.session.LANG.CONFIRMATION_PAYMENT_STATUS_PROCESSING_TEXT}</b></label>
      <label class="status-failed status-row" style="display:none;"><b/>{$smarty.session.LANG.CONFIRMATION_PAYMENT_STATUS_FAILED_TEXT}</b></label>
    </td>
  </tr>

  <tr>
  </tr>

  <tr class="status-dependent-element">
    <td class="tableContentTD tableSMContentTD" valign="top">
      {if $smarty.session.OrderInfo.PayToolType==''}
        <button class="buttonContinue" onclick="clickPayNow()" id="doPayRedirect" style="margin-left: 0;">{$smarty.session.LANG.BUTTON_3DSECURE}</button>
      {elseif $needRedirect}
        <button class="buttonContinue" onclick="clickPayNow()" id="doPayRedirect" style="margin-left: 0;">{$smarty.session.LANG.BUTTON_PAY_EXTERNAL}</button> 
      {else}
        <button class="buttonContinue" onclick="clickPayNow()" id="doPayRedirect" style="margin-left: 0;">{$smarty.session.LANG.BUTTON_PAY_WITH|replace:'%s':$PaySystemTitle}</button> 
      {/if}
    </td>
  </tr>

  </table>

  <table class="tableFooter tableSMFooter" cellpadding="0" cellspacing="0">
    <tr>
      <td class="tableFooterTD tableSMFooterTD"></td>
    </tr>
  </table>
  
  {if $CheckoutScriptSrc}
    {$CheckoutScriptHtml}
    <script src="{$CheckoutScriptSrc}"></script>
    <div id="{$CheckoutScriptSection}" style="display: none;">
        <script>
        function execCheckoutHandler() {
          {if $CheckoutScriptHandler}
            {$CheckoutScriptHandler}
          {/if}
        }
        execCheckoutHandler();
        </script>
    </div>
  {/if}

  {else} {* !needRedirect and !needOpenModalForm *}

  {if $Totals_OrderTotal > 0}
  <table class="tableContent tableSMContent" cellpadding="0" cellspacing="0" id="AuthData" name="AuthData">
    <tr>
      <td class="tableContentTD tableSMContentTD" valign="top">
        <label><b>{$smarty.session.LANG.CHECK_CACHE_TOOLTIP}<b/></label>
      </td>
    </tr>
  </table>
  
  <table class="tableFooter tableSMFooter" cellpadding="0" cellspacing="0">
    <tr>
      <td class="tableFooterTD tableSMFooterTD"></td>
    </tr>
  </table>
  
  {/if} {* Totals_OrderTotal > 0 *}
  
  {/if}

<!--
  end of payment_status.tpl
-->
 
