<!-- paci_vps_options_js.tpl -->

<script type="text/javascript">
	var pbaResources = {$plan.PlanRate|@json_encode}; // [LB] PBA resource rates
	//var provParams = {$prov|@json_encode};
	var token = '{$token}';
	var veConfig = {$state->aps_json};

	{literal}	
	var samples = [];
	var locations = [];
	var pbaResourcesById = {};
	var pbaResourcesByName = {};
	var pbaResourcesByApsType = {};
	var currentSampleIndx = 0;
	var osByApsId = {};
    var pleskPanel = {};
	
	function filterResourcesByType(resources, type){
		var result = [];
		for(idx in resources){
			var resource = resources[idx];
			if(('aps' in resource) && (resource.aps.type === type)){
				result.push(resource);
			}
		}
		return result;
	}
	var uomMultipliers = [
		{"uom": ["kb", "mb", "gb"], "multiplier": 1024},
		{"uom": ["khz", "mhz", "ghz"], "multiplier": 1000},
		{"uom": ["kbit/s", "mhz", "ghz"], "multiplier": 1000}
	]
	function convertUnits(value, fromUOM, toUOM){
		//console.log("converting " + value + " " +fromUOM+ " to " + toUOM);
		//console.log("toUOM " + toUOM);
		fromUOM = fromUOM.toLowerCase();
		toUOM = toUOM.toLowerCase();
        if(fromUOM === toUOM){
            return value;
        }
		for(indx in uomMultipliers){
			fromUOMIndx = uomMultipliers[indx].uom.indexOf(fromUOM);
			toUOMIndx = uomMultipliers[indx].uom.indexOf(toUOM);
            if(fromUOMIndx != -1 && toUOMIndx!=-1){
                var mult = Math.pow(uomMultipliers[indx].multiplier, (fromUOMIndx - toUOMIndx));
                var res = value*mult;
				//console.log("result: " + res);
                return res;
            }
		}
        console.error("cannot convert " + fromUOM + " to " + toUOM);
	}
	function prepareSamples(samples) {
	    //sort first by SortOrder (configured in PBA) then by price
		samples.sort(function(a,b){
			var resA = pbaResourcesById[a.resourceID];
			var resB = pbaResourcesById[b.resourceID];
			return (resA.SortOrder == resB.SortOrder) ? a.price - b.price : resA.SortOrder - resB.SortOrder;
		});
		function prepareHwLimits(hwProperty, name, unitInSample){

			var pbaRes = pbaResourcesByName[name];
            if ( pbaRes ) {
              hwProperty.value = convertUnits(hwProperty.value, unitInSample, pbaRes.UOM_ID);
			  hwProperty.max = convertUnits(hwProperty.max, unitInSample, pbaRes.UOM_ID);
			  hwProperty.step = convertUnits(hwProperty.step, unitInSample, pbaRes.UOM_ID);
			  hwProperty.uom = pbaRes.UnitOfMeasure;
            }
		}

	    for (var i = 0; i < samples.length; i++) {
			prepareHwLimits(samples[i].hardware.memory, "ram", "mb");
			prepareHwLimits(samples[i].hardware.disk.space, "hdd", "gb");
			prepareHwLimits(samples[i].hardware.cpu.power, "power", "mhz");
			// sample widget's ID is an index in samples array
	        samples[i].indx = i;
	    }
	}
	function loadOsTemplates(){
		var deferred = jQuery.Deferred();
		var requests = [];

		for(idx in samples){
			requests.push(jQuery.ajax({
	        url : "/aps/2/resources/" + samples[idx].aps.id + "/os",
	        headers : {
	            'APS-Token' : token
	        }}));
		}
		jQuery.when.apply($, requests).done(function (oses){
			//var oses = JSON.parse(result);
			for(i in oses){
				osByApsId[oses[i].aps.id] = oses[i];
			}
			deferred.resolve();
		}).fail(function(error){
			console.error("Cannot load OS templates. Make sure PACI service is running");
		});
		return deferred;
	}
	function prepareLocations(locations) {
		locations.sort(function(locationA, locationB){
			return locationA.name > locationB.name;
		});
	}

    function preparePleskPanel(limits) {
        var pleskConf = [];
        for ( idx in limits ) {
            var limit = limits[idx];
            if (("apsType" in limit) && limit.apsType.startsWith("http://www.parallels.com/aps/plesk/configuration/"))
                pleskConf.push(limit);
        }

        jQuery.map(pbaResourcesById, function (pbaResourceById) {
            if ( pbaResourceById.IncludedInComposite != "") {
              var simpleResList = pbaResourceById.IncludedInComposite.split(';');
              for ( idx in pleskConf ) {
                  if ( jQuery.inArray(String( pleskConf[idx].id ), simpleResList) > -1 )
                      pleskPanel[pbaResourceById.ID] = pbaResourceById;
              }
            }
        });
    }

	function prepareResources() {
	    var deferred = jQuery.Deferred();
	    var pbaResourcesByResourceId = {};
		var resourceIdByApsResourceId = {};

	    jQuery.map(pbaResources, function (pbaResource) {
	        pbaResourcesByResourceId[pbaResource.ResourceID] = pbaResource;
	    });
		jQuery.map(pbaResources, function (pbaResource) {
	        pbaResourcesById[pbaResource.ID] = pbaResource;
	    });
	    jQuery.ajax({
	        url : "/aps/2/resources/",
	        headers : {
	            'APS-Token' : token
	        }
	    }).done(function (rootApsResources) {
			var serviceTemplates = filterResourcesByType(rootApsResources, 'http://parallels.com/aps/types/pa/serviceTemplate/1.1');
			samples = filterResourcesByType(rootApsResources, 'http://www.parallels.com/infrastructure/virtual-environment/sample/1.0');
			locations = filterResourcesByType(rootApsResources, 'http://www.parallels.com/infrastructure/location/1.0');
		    if (samples.length == 0) {
		        console.error("Samples not found in APS resources");
		        return false;
		    }
			if(serviceTemplates.length == 0){
				console.error("Service Template not found in APS resources");
				return false;
			}
			// from "limits" we get PA resource ID's
			jQuery.ajax({
			    url : "/aps/2/resources/" + serviceTemplates[0].aps.id + "/limits",
			    headers : {
			        'APS-Token' : token
			    }
			}).done(function (limits) {
				jQuery.map(limits, function(limit){
					//if('apsId' in limit){
						resourceIdByApsResourceId[limit.apsId] = limit.id;
					//}
					if('property' in limit){
						pbaResourcesByName[limit.property] = pbaResourcesByResourceId[limit.id];
					}
					pbaResourcesByApsType[limit.apsType] = pbaResourcesByResourceId[limit.id];
				});
				for(indx in samples){
                    var sample = samples[indx];
                    var pbaResource = pbaResourcesByResourceId[resourceIdByApsResourceId[sample.aps.id]];
                    if ( !pbaResource ) continue;
                    sample.resourceID = pbaResource.ID;
                    sample.price = pbaResource.RecurringFee;
                }
                prepareSamples(samples);
                prepareLocations(locations);
                preparePleskPanel(limits);
				loadOsTemplates().done(function(){
					deferred.resolve();
				});
			});
		});

	    return deferred;
	}
	jQuery( document ).ready(function() {
		prepareResources().done(function(){
			var pbaRes;
			var rowIndex = 0;
			var sample = samples[currentSampleIndx];
			updateTotalPrice();
			// Hardware
			pbaRes = pbaResourcesByName['cpu'];
            if ( pbaRes ) {
			  var cpuSlider = jQuery('#sliderTmpl').tmpl({
					id : 'cpu_number',
					pbaRes: pbaRes,
					step: sample.hardware.cpu.number.step,
					indx: rowIndex ++,
					label : (pbaRes.StoreText !='')? pbaRes.StoreText: pbaRes.Name
				}).insertBefore('#additional');
            }
			pbaRes = pbaResourcesByName['ram'];
            if ( pbaRes ) {
                jQuery('#sliderTmpl').tmpl({
					id : 'memory',
					step: sample.hardware.memory.step,
					indx: rowIndex ++,
					pbaRes : pbaRes,
					label : (pbaRes.StoreText !='')? pbaRes.StoreText: pbaRes.Name
				}).insertBefore('#additional');
            }
			pbaRes = pbaResourcesByName['hdd'];
            if ( pbaRes ) {
				jQuery('#sliderTmpl').tmpl({
					id : 'disk_space',
					step: sample.hardware.disk.space.step,
					indx: rowIndex ++,
					pbaRes : pbaRes,
					label : (pbaRes.StoreText !='')? pbaRes.StoreText: pbaRes.Name
				}).insertBefore('#additional');
            }
			function needToShow(pbaRes){
				return (pbaRes && (Number(pbaRes.IncludedValue) < Number(pbaRes.UpperLimit) || 
						(Number(pbaRes.UpperLimit) == -1 && Number(pbaRes.IncludedValue) != -1)));
			}
			function initialValue(pbaRes){
				return ('Amount' in pbaRes) ? Number(pbaRes.Amount) + Number(pbaRes.IncludedValue) : pbaRes.IncludedValue;
			}
			var sliderIds = [];
			pbaRes = pbaResourcesByApsType['http://www.parallels.com/infrastructure/virtual-environment/ip-v4-address/1.0'];
			if(needToShow(pbaRes)){
				jQuery('#numberFieldTmpl').tmpl({
					id : 'ipv4',
					pbaRes: pbaRes,
					value: initialValue(pbaRes),
					label : (pbaRes.StoreText !='')? pbaRes.StoreText: pbaRes.Name,
					type: "spin"
				}).insertBefore('#total');
				sliderIds.push('ipv4');
			}
			pbaRes = pbaResourcesByApsType['http://www.parallels.com/infrastructure/virtual-environment/ip-v6-address/1.0'];
			if(needToShow(pbaRes)){
				jQuery('#numberFieldTmpl').tmpl({
					id : 'ipv6',
					pbaRes: pbaRes,
					value: initialValue(pbaRes),
					label : (pbaRes.StoreText !='')? pbaRes.StoreText: pbaRes.Name,
					type: "spin"
				}).insertBefore('#total');
				sliderIds.push('ipv6');
			}
			pbaRes = pbaResourcesByName['inboundTraffic'];
			if(needToShow(pbaRes)){
				jQuery('#numberFieldTmpl').tmpl({
					id : 'traffic_in',
					pbaRes: pbaRes,
					value: initialValue(pbaRes),
					label : (pbaRes.StoreText !='')? pbaRes.StoreText: pbaRes.Name,
					type: "spin"
				}).insertBefore('#total');
				sliderIds.push('traffic_in');
			}
			pbaRes = pbaResourcesByName['outboundTraffic'];
			if(needToShow(pbaRes)){
				jQuery('#numberFieldTmpl').tmpl({
					id : 'traffic_out',
					pbaRes: pbaRes,
					value: initialValue(pbaRes),
					label : (pbaRes.StoreText !='')? pbaRes.StoreText: pbaRes.Name,
					type: "spin"
				}).insertBefore('#total');
				sliderIds.push('traffic_out');
			}
			pbaRes = pbaResourcesByName['backupSpace'];
			if(needToShow(pbaRes)){
				jQuery('#numberFieldTmpl').tmpl({
					id : 'backup_space',
					pbaRes: pbaRes,
					value: initialValue(pbaRes),
					label : (pbaRes.StoreText !='')? pbaRes.StoreText: pbaRes.Name,
					type: "spin"
				}).insertBefore('#total');
				sliderIds.push('backup_space');
			}
			pbaRes = pbaResourcesByName['imageSpace'];
			if(needToShow(pbaRes)){
				jQuery('#numberFieldTmpl').tmpl({
					id : 'image_space',
					pbaRes: pbaRes,
					value: initialValue(pbaRes),
					label : (pbaRes.StoreText !='')? pbaRes.StoreText: pbaRes.Name,
					type: "spin"
				}).insertBefore('#total');
				sliderIds.push('image_space');
			}


			//populateLocationList();
			populateOsList();
            populatePleskPanel();
			restoreState();
			jQuery('.fieldsArea').show();
			//make spinners
			sliderIds.map(function(id){
				SW.Widget.Spin.convert(document.getElementById(id));
			});
			//make table look zebra
			jQuery('#resourcesTable > tbody > tr.generalRow:visible').each(function(index, row){
				if(index%2 == 0){
					jQuery(row).addClass("oddRowTable");
				}
			});
			jQuery('#resourcesTable > tbody > tr.additionalRow:visible').each(function(index, row){
				if(index%2 == 0){
					jQuery(row).addClass("oddRowTable");
				}
			});

            if ( jQuery('#resourcesTable > tbody > tr.generalRow:visible').length == 0 ) {
                jQuery('#general').hide();
                jQuery('#generalheader').hide();
            }
            if ( jQuery('#resourcesTable > tbody > tr.additionalRow:visible').length == 0 ) {
                jQuery('#additional').hide();
                jQuery('#additionalheader').hide();
            }
			jQuery('#loading').hide();
		});
		jQuery("#hostname").keyup(function() {
			validateHostname();
		});
	});
	function restoreState(){
		if('hostname' in veConfig){
			jQuery('#hostname').val(veConfig.hostname);
		}
		currentSampleIndx = 0;
	}
	function calcLimits(sampleLimits, pbaRes){
		return {
			min : sampleLimits.value,
			max : (pbaRes!=null && pbaRes.UpperLimit!=-1) ? Math.min(sampleLimits.max, pbaRes.UpperLimit) : sampleLimits.max
		}
	}
	function populateLocationList(){
		if(locations.length > 0){
			jQuery('#locationsList').show();
			
			for(idx in locations){
				jQuery('#radioButtonTmpl').tmpl({id: locations[idx].aps.id, label: locations[idx].name, name: "locations", fee: 0}).appendTo('#locationTable');
			}
			jQuery("input:radio[name=locations][disabled=false]:first").attr('checked', true);
		}
	}
	function populateOsList(){		
		var osIds = samples[currentSampleIndx].templates.os;
        var winos = false, linos = false;
		for(idx in osIds){
            if (!osByApsId[osIds[idx]]) continue;
            var divID;
            var ostype = osByApsId[osIds[idx]].osType.toLowerCase();
            if (ostype.indexOf('linux') != -1) {
                linos = true;
                divID = '#ossTable';
            } else {
                winos = true;
                divID = '#winTable';
            }
			jQuery('#radioButtonTmpl').tmpl({id: osIds[idx], label: osByApsId[osIds[idx]].readableName, name: "oss", fee: 0}).appendTo(divID);
		}
		var selected = ('osId' in veConfig) ? veConfig.osId : samples[currentSampleIndx].templates.defaultOS;
		jQuery('#' + selected).prop('checked', true);
		if ( !linos ) jQuery('#linTd,#linHeader').hide();
        if ( !winos ) jQuery('#winTd,#winHeader').hide();

	}

    function populatePleskPanel() {
        var cur_id, cur_name = "pleskPanel", cur_label, cur_textprice, fee;

        for(idx in pleskPanel){
            cur_id = pleskPanel[idx].ID;
            cur_label = pleskPanel[idx].Name;
            cur_textprice = locale["CURRENCY_PREFIX"] + pleskPanel[idx].RecurringFee + locale["CURRENCY_POSTFIX"];
            cur_textprice += month;
            fee = pleskPanel[idx].RecurringFee;
            jQuery('#radioButtonTmpl').tmpl({id: cur_id, label: cur_label, name: cur_name, textprice: cur_textprice, fee: fee}).appendTo('#pleskTable');
            if ( pleskPanel[idx].Amount == 1) {
                jQuery('#' + cur_id).prop('checked', true);
                jQuery('#price_pleskPanel').attr("price", fee);
                updateTotalPrice();
            }
        }

        if ( jQuery('#pleskTable tr').length < 2 ) jQuery('#pleskblock').hide();

    }

    function calcPriceRadio(obj) {
        var price_obj_name = "price_" + obj.name;
        var fee = obj.attributes['fee'].value;
        jQuery('#' + price_obj_name).attr("price", fee);

        updateTotalPrice();
        if (obj.name === "oss")
        	validateHostname();
    }

	function updateTotalPrice(){
		var total = Number(cloud_base_price_month);
		jQuery('[price]').map(function(){
			total += Number(jQuery(this).attr("price"));
		});
		cloudUpdatePrice('cloud_total_month', total);
	}
	function onParamChanged(e, name){
		//console.log('onParamChanged(' + name + ')');
		var control = jQuery('#' + name);
		var amount = Number(control.val());
		var included = Number(control.attr('included'));
		var limit = Number(control.attr('limit'));
		if(amount < included) {
			control.val(included);
			return;
		}
		if(limit != -1 && amount > limit) {
			control.val(limit);
			return;
		}
		var fee = Number(control.attr('fee'));
		if(fee) {
			cloudUpdatePrice('price_'+name, (amount-included)*fee);
			updateTotalPrice();
		}
	}
	function onSubmitForm() {
	    prepareVeConfig();

	    jQuery('[pbaresid]').map(function () {
	        var resId = jQuery(this).attr("pbaresid");
	        var additional = Number(jQuery(this).val()) - Number(jQuery(this).attr("included"));
	        $('<input>').attr({
	            type : 'hidden',
	            name : resId
	        }).val(additional).appendTo('form');
		if ( jQuery(this).attr("id").indexOf('cpu_number') != -1 ) {
			pbaResPower = pbaResourcesByName['power'];
 			var core_power = Number(pbaResPower.IncludedValue) / Number(jQuery(this).attr("included"));
            var power_val = core_power * ( Number(jQuery(this).val()) -  Number(jQuery(this).attr("included")) );
	                $('<input>').attr({
	                    type : 'hidden',
        	            name : pbaResPower.ID
                	}).val(power_val).appendTo('form');
		}
	    });
	}
	function prepareVeConfig() {

	    var provisioningParams = {
	        "aps" : {
	            "type" : "http://www.parallels.com/infrastructure/virtual-environment/1.0"
	        },
	        "name" : jQuery('#hostname').val(),
	        "hostname" : jQuery('#hostname').val(),
			"osId" : jQuery('input:radio[name=oss]:checked').val()
        };
	    jQuery('#aps_json').val(JSON.stringify(provisioningParams));
	}
	function validateHostname() {
		var hostname = jQuery('#hostname').val();
		var isCommonValid = true, isWinValid = true;
		if (hostname !== "") {
			var winDottedRegex = new RegExp(/^[a-zA-Z][a-zA-Z0-9\\-]{0,13}[a-zA-Z0-9]$/);
			var commonDottedRegex = new RegExp(/^[a-zA-Z0-9][a-zA-Z0-9\\-]{0,61}[a-zA-Z0-9]$/);
			if (jQuery('#winTd input').is(':checked'))
				isWinValid = winDottedRegex.test(hostname);
			else
				isCommonValid = commonDottedRegex.test(hostname);	
		}
		jQuery("#error__CommonHost").toggleClass("widgetHidden", isCommonValid);
		jQuery("#error__WinHost").toggleClass("widgetHidden", isWinValid);
		if (isCommonValid && isWinValid)
			enableContinue();
		else
			disableContinue()
	}
	function disableContinue() {
		var $button = jQuery('#chooseVirtualServer_buttonContinue');
		$button.attr('disabled', true);
		$button.toggleClass("SWbutton_Disable", true);
	}
	function enableContinue() {
		var $button = jQuery('#chooseVirtualServer_buttonContinue');
		$button.removeAttr("disabled");
		$button.toggleClass("SWbutton_Disable", false);
	}
	{/literal}
</script>
<!-- end of paci_vps_options_js.tpl -->

