<!-- vpsng_configs_js.tpl -->
<script type="text/javascript">
  var resRates = {$plan.PlanRate|@json_encode};
  var provParams = {$prov|@json_encode};
  var token = '{$token}';
  var st_guid = '';
  {literal}
  var types = {};
  var resources = {};
  var configs = [];
  var backups = {"options":[]};
  var apsResources = {};
  var cloud_res_prices = {};
  var default_slider_width = 916; //slider width

console.clear();
  var screenPattern = [
    {"node" : "mainControlsTR", 
     "resources" : [{"type": "main_combo", "name":"os", "title":locale["VPSNG_RESOURCES_OS"]}],
     "controls_count": 0
    },
    {"node" : "slidersTab", 
     "resources" : [
                    {"type": "slider", "name":"power", "title":locale["VPSNG_RESOURCES_CPU"]},
                    {"type": "slider", "name":"number", "title":locale["VPSNG_RESOURCES_CPU_CORES"]},
                    {"type": "slider", "name":"memory", "title":locale["C2U_RESOURCES_RAM"]},
                    {"type": "slider", "name":"space", "title":locale["C2U_RESOURCES_DISK"]}
                   ],
     "controls_count": 0
    },
    {"node" : "advSettingsLeftTD", 
     "resources" : [
                    {"type": "main_combo", "name":"backups", "title":locale["VPSNG_RESOURCES_BACKUP"]},
                    {"type": "slider", "name":"backupSpace", "title": locale["VPSNG_RESOURCES_BacupSpace"]},
                   ]
    },
    {"node" : "advSettingsRightTD", 
     "resources" : [
                    {"type": "other", "size": 3, "name":"IPv4", "title": locale["VPSNG_RESOURCES_IPv4"]},
                    {"type": "other", "size": 3, "name":"IPv6", "title": locale["VPSNG_RESOURCES_IPv6"]},
                    {"type": "slider", "name":"bandwidth", "title":locale["VPSNG_RESOURCES_BANDWIDTH"]},
                    {"type": "slider", "name":"outboundTraffic", "title": locale["VPSNG_RESOURCES_TrafficOUT"]},
                    {"type": "slider", "name":"inboundTraffic",  "title": locale["VPSNG_RESOURCES_TrafficIN"]}
                   ]
    },
  ];
  
  var resourceStep = { "outboundTraffic" : {"step": 5 , "unit": "gb"},
                     "inboundTraffic" : {"step": 5, "unit": "gb"} 
                     };
 
  var uom = [{"uom": ["kb", "mb", "gb", "tb"], "quantity": 1024},
             {"uom": ["kbit/s", "mbit/s", "gbits/s"], "quantity": 1000}];

  
  var resourceTitles = {};
  for (var key in screenPattern) {
    resources = screenPattern[key]["resources"];
    for (var res_key in resources) {
      resourceTitles[resources[res_key]["name"]] = resources[res_key]["title"];  
    }
  }

  jQuery.map(resRates, function(resRate) {
    cloud_res_prices[resRate.ID] = {'included_value' : resRate.IncludedValue,
    'price' : resRate.RecurringFee,
    'price_month' : 0
    };
  });

  jQuery( document ).ready(function() {
    setTimeout(function(){
    jQuery.ajax({
      url: "/aps/2/resources/",
      headers: {
        'APS-Token': token
      }
    }).done(function(data) {
      configs = parseData(data);
      if (configs.length == 0) return;
      jQuery('#configTmpl').tmpl(configs).prependTo('#topSamples');
      //call function from ./webroot/static/store-skins/parallels/js/functions.js 
      jQuery('.categoryPlansPanel div.planSmallPanel:nth-of-type(3n+3)').css({'margin-right':'0px'});

      addProvParams();
      config = getCurrentConfig();
      for (var block_key in screenPattern) {
        var block = screenPattern[block_key];
        for (var res_key in block.resources) {
          var resource = block.resources[res_key];
          switch (resource.type) {
            case "slider":
              addSlider(resource, block, config);
              break;
            case "main_combo":
              var new_tr = (block.node != "mainControlsTR")? true : false;
              addMainCombo(resource, block, config, new_tr);
              break;
            case "net_combo":
              addNetCombo(resource, block.node, config);
              break;
            case "other":
              addTextBox(resource, block.node);
              break;
          }
        }
      }
      jQuery('.conf_line').show();
      jQuery('#loading').hide();
    });
    },1000);
  });

  function getObjFromHash(objName, hash) {
    for(var key in hash) {
      if (typeof(hash[key]) != "object") continue;
      if (key == objName) {
        return hash[key];
      } else {
        obj = getObjFromHash(objName, hash[key]);
        if (obj) return obj;
      }
    }
    return false;
  }
  
  function getResRateDefaults(res) {
    var limits = {};
    var resRate = getResRate(res.id);
    if (!resRate) return false; 
    limits["step"]  = (!resourceStep[res.aps_name])? 1 : 
                   convertUOM(resourceStep[res.aps_name].step, resourceStep[res.aps_name].unit, res.pa_unit);
    limits["value"] = Number(resRate.IncludedValue);
    limits["wo_incl"] = false;
    return limits; 
  }

  function getResConfigDefaults(res, config) {
    var defaults = clone(getObjFromHash(res.aps_name, config));
    if (!defaults) return  getResRateDefaults(res);
    defaults.max = Number(convertUOM(defaults.max, res.unit, res.pa_unit));
    defaults.value = Number(convertUOM(defaults.value, res.unit, res.pa_unit));
    defaults.step = Number(convertUOM(defaults.step, res.unit, res.pa_unit));
    return defaults;
  }

  function getSliderParentNode(cur_cnt, count, node_name) {
    var three = 0;
    var two = 0;
    if (count <= 2) two = 1;
    else if (count <= 3) three = 1;
    else {
      var three_cnt = Math.round(count/3);
      for (var i=three_cnt;  i>=0; --i) {
        var two_cnt = count-(i*3);
        if (two_cnt%2 != 0) continue;
        else {
          two = two_cnt/2;
          three = i;
          break;
        }
      }
    }

    var need_create = false;
    var cl_name = "";
    var id = "";
    var slider_width = 0;
    if (three*3 >= cur_cnt) {
      need_create = ((cur_cnt%3) == 1);
      cl_name = 'collumns3';
      id = "sliderTab"+((three == 1)? 1 : Math.round(cur_cnt/three));
      slider_width = default_slider_width/3-(20);
    } else if (two*2 >= cur_cnt-(three*3)) {
      need_create = ((cur_cnt-(three*3))%2 == 1);
      cl_name = 'collumns2';
      id = "sliderTab"+((two == 1)? ""+Number(three+1) : ""+Math.round((cur_cnt-(three*3))/two));
      slider_width = default_slider_width/2-(20);
    }

    if (need_create)
      jQuery("<div id='"+id+"' class='"+cl_name+"'></div>").appendTo("#"+node_name);
    return {"id" : id, "slider_width" : slider_width};
  }

  function addSlider(res, block, config) {
    var resource = getObjFromHash(res.name, apsResources);
    if (!resource) resource = getPAResource(res);
    if (!resource || !resource.pa_id) return; 
    
    resource["title"] = res.title;
    resource["aps_name"] = res.name;
    resource["defaults"] = getResConfigDefaults(resource, config);
    if (resource.max > resource.defaults.max) resource.max = resource.defaults.max;
    if (resource["defaults"] != false && resource["res_amount"] 
        && !resource.defaults["wo_incl"]) {
      resource["res_amount"] = Number(resource["res_amount"]) + Number(resource["defaults"].value);
    }
    
    var key = 0;
    var res_length = 0;
    for (var key in screenPattern) {
      if (screenPattern[key].node == block.node) {
        for (var res_key in screenPattern[key].resources) {
            var res1 = getObjFromHash(screenPattern[key].resources[res_key].name, apsResources);
            if (!res1) res1 = getPAResource(screenPattern[key].resources[res_key]);
            if (!res1 || !res1.pa_id) continue; 
            res_length++;
         }

        break;
      }
    }

    if (block.node != "slidersTab") {
      resource["isLast"] = true;
    }
    
    if (!resource.defaults) return; 

    var parent_node = "";
    var slider_width = default_slider_width/2-(20);
    if (block.node == "slidersTab") {
      var result = 
        getSliderParentNode(screenPattern[key].controls_count+1, res_length, block.node);

      parent_node = result.id;
      slider_width = result.slider_width;
    } else  
      parent_node = block.node;

    resource["slider_width"] = slider_width;

    jQuery('#sliderTmpl').tmpl(resource).appendTo('#'+parent_node);
    if (block.node == "slidersTab")
      screenPattern[key].controls_count++;
  }
  
  function addProvParams() {
    for (key in provParams) {
      provParams[key]["pa_id"] = provParams[key]["id"];
      if (provParams[key]["value"])
        provParams[key]["res_amount"] = provParams[key]["value"];
 
      if (!provParams[key].id) continue; 
      if (key == "DomainID") {
        provParams[key].name = locale["VPSNG_RESOURCES_HOSTNAME"];
        provParams[key].hint = locale["VPSNG_RESOURCES_HOSTNAME_HINT"];
      }
      jQuery('#provParamTmpl').tmpl(provParams[key]).appendTo('#advSettingsLeftTD');
    }
  }

  function addTextBox(res, node) {
    var resource = getPAResource(res.name);
    if (resource && resource.pa_id) {

      var resRate = getResRate(resource["id"]);
      if (resRate) { 
        resource["hint"] = locale["C2U_FROM"]+" "+(Number(resRate.LowerLimit)+Number(resRate.IncludedValue))+" "+locale["C2U_TO"]+" "+resRate.UpperLimit;
        resource["max"] = resRate.UpperLimit;
        resource["min"] = Number(resRate.LowerLimit)+Number(resRate.IncludedValue);
        if (resource["res_amount"] && resRate.IncludedValue) {
          resource["res_amount"] = Number(resource["res_amount"]) + Number(resRate.IncludedValue);
        } else {
          resource["res_amount"] = Number(resRate.IncludedValue);
        }

      }
      resource["name"] = res.title;
      resource["aps_name"] = res.name
      if (res["size"]) resource["size"] = res.size;
      jQuery('#provParamTmpl').tmpl(resource).appendTo('#'+node);
    }
  }

  function getSelectedOption ( resource ) {
      for (var key in resource) { //search for resource option selected by customer
          if (!resource[key].aps) continue;
          var paID = getPAIdByApsId(resource[key].aps.id);
          var resRate = getResRate(paID);
          if (!resRate) break;
          if (resRate.Amount && resRate.Amount > 0) return resource[key].aps.id;
      }
  }

  function findDefaultOS(resid, source) { // find default OS
    var defaultValue = "";
    var aps_defaults = provParams["aps_defaults_1"];
    if ( resid == 'os' && aps_defaults ) { // search for OS selected by customer
        defaultValue = JSON.parse(aps_defaults["value"]).environmentTemplate.osId;
        if ( defaultValue != "" ) return defaultValue;
    }

    // default option from APS
    var def_key = ["default", "default"+resid, "default"+resid.toUpperCase()];

    for (k in def_key) {
      if (source[def_key[k]]) defaultValue = source[def_key[k]];
    }
    return defaultValue;
  }

  function addMainCombo(res, block, config, new_tr) {
    var resid = res.name;
    var resource = (resid=='backups')? backups : getObjFromHash(resid, config);
    
    if (resource && resource.options.length != 0) {
      var defaultValue = (resid == 'os')? findDefaultOS (resid, config['templates']) : getSelectedOption(resource.options);
      jQuery('#mainComboTmpl').tmpl({"name": res.title,
                                "aps_name": res.name,
                                "resource": resource,
                                "selected": defaultValue,
                                }).appendTo("#"+block.node);
    }
  }
  
  function getResOptions(res) {
    var options = [];
    var min = res.defaults.value;
    var included_value = (res.defaults.value && !res.defaults["wo_incl"])? res.defaults.value :  cloud_res_prices[res.pa_id].included_value;
    for (var i = min; i<=res.max; i=i+res.defaults.step) {
      var value = i - included_value;
      value = (value < 0)? 0 : value;
  
      var price = Number(cloud_res_prices[res.pa_id].price)*value;
      options.push({"true_val":i, "value": (!res.defaults["wo_incl"])? i : value, "name":getUOMTitle(res.pa_unit, i), 
                        "price": price});
    }
    return options;
  }
  
  function addNetCombo(res, node, config) {
    var resource = getObjFromHash(res.name, apsResources);
    if (!resource) resource = getPAResource(res.name);
    if (!resource) return; 

    resource["title"] = res.title;
    resource["aps_name"] = res.name;
    resource["defaults"] = getResConfigDefaults(resource, config);
    if (resource.max > resource.defaults.max) resource.max = resource.defaults.max;

    resource["options"]  = getResOptions(resource);
    if (!resource.defaults) return;
    if (resource["res_amount"] && !resource.defaults["wo_incl"]) {
      resource["res_amount"] = Number(resource["res_amount"]) + Number(resource["defaults"].value);
    }


    jQuery('#netComboTmpl').tmpl(resource).appendTo('#'+node);
  }
  
  function getPAResource(resType) {
    if (typeof resType === 'object') {
    //remove befor commit
      if (resType.path === "disk.space") resType = 'diskspace'
      else 
      resType = resType.path;
    }
    for (key in resources) {
      if (resources[key].property == "additional."+resType ||
           resources[key].property == resType) {
        resRate = getResRate(resources[key].id);
        resources[key]["pa_unit"] = resRate.UnitOfMeasure;
        resources[key]["price"] = Number(resRate.RecurringFee);
        resources[key]["pa_id"] = resRate.ID;
        resources[key]["max"] = Number(resRate.UpperLimit);
        resources[key]["sort_order"] = Number(resRate.SortOrder);
        if (resRate.Amount) {
          resources[key]["res_amount"] = resRate.Amount;
        }
        return resources[key];
      }
    }
    return false;
  }
  
  function getPAIdByApsId(apsId) {
    for (key in resources) {
      if (resources[key].apsId == apsId) {
        return resources[key].id;
      }
    }
    return false;
  }
  
  function getUOMTitle(resUOM, resValue) {
    uomIdx = getUOMIndex(resUOM);
    if (!uomIdx) return resValue + " " + resUOM;
    var uom_list = uom[uomIdx.key];
    for (var i=uom_list.uom.length-1; i>=0; i--) {
      if (uomIdx.pos == i) {
        return resValue + " " + uom_list.uom[i];
      }
      
      var val = convertUOM(resValue, resUOM, uom_list.uom[i]);
      if (val >= 1) {
        return val + " " + uom_list.uom[i];
      }
    }
    return 1;
  }

  function getUOMIndex(uomName) {
    if (!uomName) return false;
    var uomIdx = [];
    for (key in uom) {
      uomIdx["key"] = key;
      for (key1 in uom[key].uom) {
        if (uom[key].uom[key1] == uomName.toLowerCase()) {
          uomIdx["pos"] = key1;
          return uomIdx; 
        }
      }
    }
  }

  function convertUOM(value, fromUOM, toUOM) {
    fromUOMIdx = getUOMIndex(fromUOM);
    toUOMIdx = getUOMIndex(toUOM);
    if (!fromUOMIdx || !toUOMIdx) return Number(value);
   
    var diff = fromUOMIdx.pos - toUOMIdx.pos;
    if (diff > 0) {

      return Number(value)*Math.pow(Number(uom[toUOMIdx.key].quantity), Number(diff));
    }
    return Number(value)/Math.pow(Number(uom[fromUOMIdx.key].quantity),Number(diff*-1));

  }

  function getResRate(pa_id) {
    for (var resKey in resRates) {
      if (resRates[resKey].ResourceID == pa_id) {
        return resRates[resKey];
      }
    }
    return false;
  }
  
  function getApsResources(obj, path) {
    var apsRes = {};
    if (obj.type != "object") {
      apsRes = getApsResources(types.structures[obj.type]);
    } else {
      for (var key in obj.properties) {
        var _path = (typeof path !== 'undefined' && path != "")? path + "."+ key : key;
        if (obj.properties[key].type != "object" && obj.properties[key].type != "limit") {
          if (typeof types.structures[obj.properties[key].type] === 'undefined') {
            delete obj.properties[key];
            continue;
          }
        
          apsRes[key] = getApsResources(types.structures[obj.properties[key].type], _path);
        } else {
          apsRes[key] = obj.properties[key];
          apsRes[key]["path"] = _path;
          var paRes = getPAResource(apsRes[key]);
          if (!paRes) continue;
          apsRes[key]["pa_unit"] = paRes.pa_unit;
          apsRes[key]["price"] = paRes.price;
          apsRes[key]["pa_id"] = paRes.pa_id; 
          apsRes[key]["max"] = paRes.max;
          apsRes[key]["sort_order"] = Number(paRes.SortOrder);
          if (paRes["res_amount"]) 
            apsRes[key]["res_amount"] = paRes["res_amount"];
        }
      }
    }
  
    return apsRes;
  }
  
  function parseData(data) {
    var i=0;
    //get ST resources from aps
    jQuery.map(data, function(entry) {
      if (entry.aps.type != "http://parallels.com/aps/types/pa/serviceTemplate/1.0") return; 
      st_guid = entry.aps.id;
      jQuery.ajax({
        async: false,
        url: "/aps/2/resources/" + st_guid + "/limits",
        headers: {
        'APS-Token': token
        }
      }).done(function(data) {
        resources = data;
      });
    });
    
    var confIsSelected = false;
    jQuery.map(data, function(entry) {
      if (entry.aps.type == "http://www.parallels.com/infrastructure/virtual-environment/sample/1.0") {
  
  
        var pa_id = getPAIdByApsId(entry.aps.id);
        resRate = getResRate(pa_id);
        if (!resRate) return;
        entry["pa_id"] = resRate.ID;
        entry["price"] = Number(resRate.RecurringFee);
        entry["price_month"] = 0;
        entry["sort_order"] = Number(resRate.SortOrder);
        if (resRate["Amount"]) {
          confIsSelected = true;
          entry["isDefault"]=1;
          document.getElementById( 'cloud_config_id').value = entry.pa_id
        }
        configs.push(entry);
        var idx = configs.length-1;
        i++;
        jQuery.ajax({
          async: false,
          url: "/aps/2/resources/"+entry.aps.id+"/oses",
          headers: {
          'APS-Token': token
          }
        }).done(function(data) {
          configs[idx].templates["os"]["options"] = JSON.parse(data);
        });
     } else if (entry.aps.type == "http://www.parallels.com/infrastructure/virtual-environment/backup-schedule/1.0") {
          var pa_id = getPAIdByApsId(entry.aps.id);

          resRate = getResRate(pa_id);
          if (!resRate) return;
          entry["pa_id"] = resRate.ID;
          backups["options"].push(entry);
      }
    });
    if (configs.length != 0) { 
      jQuery.ajax({
         async: false,
         url: "/aps/2/types?implementing("+configs[0].aps.type+")",
         headers: {
         'APS-Token': token
         }
      }).done(function(data) {
         types = data[0];
      });
      apsResources = getApsResources(types.properties.hardware);
    }

    configs.sort(function(a, b) {
         return (a.sort_order==b.sort_order)? a.price-b.price : a.sort_order-b.sort_order;
         });

    if (!confIsSelected) { 
      configs[0]["isDefault"]=1;
      document.getElementById( 'cloud_config_id').value = configs[0].pa_id;
    }
 
    return configs;
  }
 
  function clone(o) {
    if(!o || "object" !== typeof o)  {
      return o;
    }
    var c = "function" === typeof o.pop ? [] : {};
    var p, v;
    for(p in o) {
      if(o.hasOwnProperty(p)) {
        v = o[p];
        if(v && "object" === typeof v) {
          c[p] = clone(v);
        }
        else c[p] = v;
      }
    }
    return c;
  }

  function getConfigById(id) {
    for(key in configs) {
      if (configs[key].aps.id == id) return configs[key]; 
    }
    return false;
  }

  function setConfigMonthlyPrice(id, price) {
    for(key in configs) {
      if (configs[key].aps.id == id){
        configs[key].price_month = price; 
        return true;
      }
    }
    return false;
  }

  function MovePlanPanels(id) {
    var new_conf = document.getElementById("openTiles_"+id);
    var parentNode = new_conf.parentNode;
    var childs = parentNode.getElementsByClassName("planSmallPanel");
    var currConfLine = 0;
    //get clicked line num
    for (var i=0; i<childs.length; ++i) {
      if (new_conf.id == childs[i].id) { 
        currConfLine = Math.floor((i/3)+1);
        break;
      }
    }

    var newNode = document.getElementById('topSamples');
    var nodeInitLength = newNode.getElementsByClassName("planSmallPanel").length;
    var refEl = null;
    var firstElem = 0;
    var lastElem = 0;
    //get elements idx
    if (parentNode.id ==  'topSamples') {
      newNode = document.getElementById('bottomSamples');
      refEl = newNode.firstChild;
      firstElem = currConfLine*3;
      lastElem = childs.length-1;
    } else {
      firstElem  = 0;
      lastElem = ((currConfLine*3)>=childs.length)? childs.length-1 : (currConfLine*3)-1;
    }

    //move elements
    for (var i=lastElem; i>=firstElem; --i) {
      newNode.insertBefore(childs[i], refEl);
      refEl = (parentNode.id ==  'topSamples')? newNode.firstChild :
        newNode.getElementsByClassName("planSmallPanel")[nodeInitLength];
    }

  }

  function MoveConfigurationBlock( id ) {
    var new_conf = document.getElementById("openTiles_"+id);
    var old_conf = document.getElementsByClassName("vpsSelect")[0];
    if (old_conf) old_conf.setAttribute("class", new_conf.getAttribute("class"));
    new_conf.setAttribute("class", new_conf.getAttribute("class")+" vpsSelect");
    MovePlanPanels(id);
  }

  function vpsConfigUpdated( newConfigID, eventInitiator ) {
    var config = getConfigById(newConfigID);
    document.getElementById( 'cloud_config_id').value = config.pa_id;
    if (config)
      vpsApplyConfigToControls(config);
  }

  function vpsApplyConfigToSlider(res, config) {
    var resource = getObjFromHash(res.name, apsResources);
    if (resource){
      var default_vals = null;
      var slider = null;
      default_vals = getResConfigDefaults(resource, config);
      var value = default_vals.value;
      var max = default_vals.max;
      var step = default_vals.step;
      slider = getSliderById(resource.pa_id);
      if (slider) {
        slider.n_step = step;
        slider.f_setMin(value);
        slider.f_setMax(max);
        slider.f_setValue(value);
        document.getElementById(resource.pa_id+"_slider_minValue").innerHTML=value;
      }
    }
  }
 
  function vpsApplyOptionsToCombo(parent_name, aps_name, options) {
    var parent_el = document.getElementById(parent_name);
    if (!parent_el) return;
    var el = parent_el.getElementsByTagName('*');
    for (var i=0; i<el.length; i++){
      var children = el[i];
      if (children.nodeType == 1) {
        var attr = children.getAttribute("aps_name");
        if (attr && attr == aps_name) {
          children.innerHTML = options;
          cloudOtherResUpdated(null, children.id ,true);
          return;
        }
      }
    }
  }

  function optionsToHTML(res) {
    var html = "";
    var options = res.options;
    
    for (var i in options) {
      var selected = (res.defaults.value==options[i].true_val)? "selected" : "";
      html = html+ "<option value="+options[i].value+" price="+options[i].price+">"+options[i].name+"</option>";
    }
    return html;
  }

  function optionsMainComboToHTML(options, default_val) {
      var html = "";
      for (var i in options) {
        var selected = ( options[i].aps.id == default_val) ? "selected" : "";
        html += "<option " + selected + " value="+options[i].aps.id + " aps_id=" + options[i].aps.id + ">" + options[i].name + "</option>";
      }
      return html;
  }

  function vpsApplyConfigToControls(config) {
    for (var block_key in screenPattern) {
      var block = screenPattern[block_key];
      for (var res_key in block.resources) {
        var resource = block.resources[res_key];
        //refresh only
        res = getObjFromHash(resource.name, apsResources);
        if (!res) res = getObjFromHash(resource.name, config); // for os
        if (!res) continue;
        switch (resource.type) {
          case "slider":
            vpsApplyConfigToSlider(resource, config)
          break;
          case "main_combo": // OS changes
            var default_val = findDefaultOS(resource.name, config["templates"]);
            var options = optionsMainComboToHTML(res["options"], default_val);
            vpsApplyOptionsToCombo(block.node, resource.name, options);
            break;
          case "network":
            if (res.pa_id) {
              res["defaults"] = getResConfigDefaults(res, config);
              res["options"] = getResOptions(res);
              var options = optionsToHTML(res);
              vpsApplyOptionsToCombo(block.node, resource.name, options);
            }
          break;
        }
      }
    }
  }

  function cloudConfigCalcPrices(){
    cloudOneConfigCalcPrices(getCurrentConfig());
  }
  
  function cloudOneConfigCalcPrices(config){
    if (!config) return;
    var configMonthlyPrice = config.price;
   
    for (key in cloud_res_prices) {
      configMonthlyPrice +=  cloud_res_prices[key].price_month;
    }
    
    setConfigMonthlyPrice(config.aps.id, configMonthlyPrice);
  }
  
  function cloudRedrawConfigPrices(){
    return;
    var oldLiveIndex = -1;
    var newLiveIndex = -1;
    var configID = '';
    for (var i=0; i<=cloudTree.length-1; i++){
      if(cloudTree[i].id != 'config') continue;
      configID = cloudTree[i].config_id;
      
      cloudUpdatePrice('cloud_total_month',cloudTree[i].price_month, cloudPriceTmpl, cloud_reg_digits);
    }
  }
  {/literal}
</script>
<!-- end of vpsng_configs_js.tpl -->

