<!--
  c2u_custom_js.tpl
-->
<!-- Scripts -->

<script>
{if !$valid_browser}
SW.Signal.addLoadEvent(addInputsEvent);
{/if}

{literal}

//find all Resource input fields
function resInputsList() {
	  var divInputs = document.getElementsByName('div_inputs');
	  var resInputs = new Array();
	  var k=0;

	  	
	  for (var i=0; i<divInputs.length; i++) {
		  var inputObj = divInputs[i].getElementsByTagName('INPUT');
		  if (inputObj.length==0) continue;
		  for (var j=0; j<inputObj.length; j++) {
		  	resInputs[k] = inputObj[j];
		  	k++;
		  }
	  }

	  return resInputs;	  	
}



	// Add events, catching change in Resource value inputs with PASTE from clipboard
  
  function addInputsEvent () {

	  var resInputs = resInputsList();
	  
	  if (resInputs.length==0) return;
	  for (var i=0; i<resInputs.length; i++) {
	      if (resInputs[i].addEventListener) {    // Firefox, Opera, Google Chrome and Safari
	    	  resInputs[i].addEventListener ('textInput', OnTextInput, false);    // Google Chrome and Safari
	      }
	  }
  }

      // Google Chrome and Safari
  function OnTextInput (event) {
	  
	 checkAllResValue();
  }
      // Firefox, Google Chrome, Opera, Safari from version 5
  function OnInput (event) {
	checkAllResValue();
  }

 
  
    function cloudRedrawAllCustom(){
      for (var res_id in cloud_res_prices){
          cloudRedrawRes(res_id);
      }
    }

	function setErrorClassName(obj, classErrName, err) {
		if (!err)
			obj.className = obj.className.replace(classErrName, '');
		else {
			if (obj.className.indexOf(classErrName)==-1) 
				obj.className += classErrName;	
			
		}	
	}

	function checkResValue(resObj){

        var limits = determineSlidersLimits( resObj.attributes['res_id'].value );
		var resValNum = Number(resObj.value);

    	if (isNaN(resValNum) || resValNum < limits['min'] || resValNum > limits['max'])
        	return false;
    	else
        		return true; 
	} 

	function checkAllResValue() {
		var resInputs = resInputsList();
		if (resInputs.length==0) return;
		var err = false;
		var errInForm = false;
		for(var i=0; i<resInputs.length; i++) {
			err = !checkResValue(resInputs[i]);
			setErrorClassName(resInputs[i], ' fieldError', err);
			var objID = resInputs[i].id;
			resID = objID.substring(objID.indexOf('__')+2);
			cloudResSliderMoved(resID);
			if (err) errInForm = true;
		}
		CanContinue(errInForm);
	}

	function CanContinue(err) {
  	  	var buttonObj = document.getElementById('editplan_buttonContinue');
  	  	var objSwitcherSliders = document.getElementById('switcherSliders');
    	buttonObj.disabled = err;
	    setErrorClassName(buttonObj, ' SWbutton_Disable', err);
	    	if (err)
	    		objSwitcherSliders.attributes['onclick'].value = 'alert(locale["ERROR_FIELDS_GENERAL"])';
	    	else 
	    	  		objSwitcherSliders.attributes['onclick'].value = 'switchSliders();';
	}
	
	  	
    function cloudResSliderMoved(resID){
      var priceShowing = document.getElementById('price_hour_'+resID);
      var obj = document.getElementById('cloud_slider_numvalue__'+resID); 
      if(!obj){
        alert(locale["C2U_ERROR_JS_CANNOT_FIND_OBJECT"]+' cloud_slider_numvalue__'+resID );
        return;
      }

      value = obj.value;
      
      if(!cloud_switching_config && document.getElementById( 'cloud_config_id').value!='custom'){
        cloudConfigUpdated('custom','slider_moved');
      }  
      
      // update custom config resource value
      if(!cloud_switching_config && document.getElementById( 'cloud_config_id').value=='custom'){
        for (var i=0; i<=cloudTree[cloud_custom_config_index].res_values.length-1; i++){
          if(cloudTree[cloud_custom_config_index].res_values[i].id==resID){
            cloudTree[cloud_custom_config_index].res_values[i].value = value;
            break;
          }          
        }
      }
          
      cloudRedrawRes(resID);
      if(!cloud_switching_config){
       cloudOneConfigCalcPrices(cloud_custom_config_index);
       cloudUpdateTotal('slider_moved');   
      }
    }
  
	function cloudSwitchIncludedRes(incl_val, obj, txtobj) {

		if(!obj){
		 	alert(locale["C2U_ERROR_JS_CANNOT_FIND_OBJECT"] + ' ' +obj.id );
			return;
		}
		if(!txtobj){
		 	alert(locale["C2U_ERROR_JS_CANNOT_FIND_OBJECT"] + ' '  + txtobj.id);
			return;
		}
	      
	    if (incl_val > 0) {
	    	obj.innerHTML = incl_val;
	    	obj.style.display = '';
	    	txtobj.style.display = '';
	    }
	    else {
	    	obj.style.display = 'none';
	    	txtobj.style.display = 'none';
	    }  	
	      		
	}  
    function cloudRedrawRes(resID)
    {
      var priceShowing = document.getElementById('price_hour_'+resID);
      var obj = document.getElementById('cloud_slider_numvalue__'+resID); 
      var inclObj = document.getElementById('included_'+resID);
      var inclTextObj = document.getElementById('includedtext_'+resID);
      if(!obj){
        alert(locale["C2U_ERROR_JS_CANNOT_FIND_OBJECT"]+' cloud_slider_numvalue__'+resID );
        return;
      }
      if(!inclObj){
        alert(locale["C2U_ERROR_JS_CANNOT_FIND_OBJECT"]+' included_'+resID );
        return;
      }
      if(!inclTextObj){
        alert(locale["C2U_ERROR_JS_CANNOT_FIND_OBJECT"]+' includedtext_'+resID );
        return;
      }      
      var value = 0;
      var isValid = checkResValue(obj);

      if (isValid)  value = obj.value;
      
      var textObj = document.getElementById('cloud_slider_textvalue__'+resID); 
      if(!textObj){
        alert(locale["C2U_ERROR_JS_CANNOT_FIND_OBJECT"]+' cloud_slider_textvalue__'+resID);
        return;
      }
      textObj.innerHTML = value;
      
      var res_incl = cloud_res_prices[resID].included_value; 
	  var incl_val = 0;
	  if (value>0) 
		  incl_val = Math.floor(Number(res_incl) / Number(value));
      
      cloudSwitchIncludedRes(incl_val, inclObj, inclTextObj);	
      
      res_price = cloud_res_prices[resID].price_hour * value;
      res_value_month = value*cloud_hours_in_month - res_incl;
      if (res_value_month < 0) res_value_month = 0;
      res_price_month = res_value_month*cloud_res_prices[resID].price_hour;
      cloud_res_prices[resID].price_month = res_price_month;
      
      if(priceShowing){
        cloudUpdatePrice('price_hour_'+resID, res_price, cloudPriceTmpl, cloud_hour_digits);
        cloudUpdatePrice('price_month_'+resID, res_price_month, cloudPriceTmpl, cloud_reg_digits);
      }
      
    }

    function switchSliders() {
        var divInputs = document.getElementsByName('div_inputs');
        var divSliders = document.getElementsByName('div_sliders');
        var objSwitcherOn = document.getElementById('switcherSlidersOn');
        var objSwitcherOff = document.getElementById('switcherSlidersOff');
        var displayInp = '';
        var displaySl = ''; 

        if (divInputs.length==0 || divSliders.length==0) return;
        if (divInputs[0].style.display=='none') {
             displaySl = 'none';
             displayInp = '';
        }
        else {
        	 cloudApplyConfigToSliders();	            
             displaySl = '';
             displayInp = 'none';
            
        }     
        objSwitcherOn.style.display = displayInp;
        objSwitcherOff.style.display = displaySl;
		if (divInputs.length>0) {
	        for (var i=0; i<divInputs.length; i++)
	        	divInputs[i].style.display = displayInp;
		}    	
		if (divSliders.length>0) {
	        for (var i=0; i<divSliders.length; i++)
	        	divSliders[i].style.display = displaySl;
		}
		
		    	
    }
  {/literal}
  
</script>
<!-- /Scripts @@@@@ -->

      
<!-- end of c2u_custom_js.tpl -->

  
  
  



