//  domain_prov_iejs.tpl

{literal}
  function provToggleTRDisplay(tr, showHide) {
    var tr = SW.DOM.getElement(tr);
    if (tr == null) return;

    var space_tr = SW.DOM.getElement('space_' + tr.id);
    var display_style = "table-row";
    if(document.all) display_style = "block";

    if (showHide) {
      tr.style.display = display_style;
      space_tr.style.display = display_style;
      SW.DOM.enableWidgets(tr);
    } else {
      tr.style.display = 'none';
      space_tr.style.display = 'none';
      SW.DOM.disableWidgets(tr);
    }
  }

  var merge_condition = { 0 : {0:0, 1:1, 2:2, 3:3, 4:4},
                         10 : {1:10, 11:11, 4:13},
                         14 : {1:14, 2:15, 4:16, 17:17},
                         18 : {1:18, 2:20, 3:21, 4:22},
                         23 : {1:23, 2:24, 4:25, 26:26},
                         27 : {1:27, 2:28, 3:29, 4:30, 31:31}};
  var split_condition = { 0 : [ 0,  0],
                          1 : [ 0,  1],
                          2 : [ 0,  2],
                          3 : [ 0,  3],
                          4 : [ 0,  4],
                         10 : [10,  1],
                         11 : [10, 11],
                         13 : [10,  4],
                         14 : [14,  1],
                         15 : [14,  2],
                         16 : [14,  4],
                         17 : [14, 17],
                         18 : [18,  1],
                         20 : [18,  2],
                         21 : [18,  3],
                         22 : [18,  4],
                         23 : [23,  1],
                         24 : [23,  2],
                         25 : [23,  4],
                         26 : [23, 26],
                         27 : [27,  1],
                         28 : [27,  2],
                         29 : [27,  3],
                         30 : [27,  4],
                         31 : [27, 31]
                        };
  var dst_list = [0, 1, 2, 3, 4, 11, 17, 26, 31];
  var class_msgs = { 0 : 'IEDR_CLASS_BODY_CORPORATE',
                    10 : 'IEDR_CLASS_NATURAL_PERSON',
                    14 : 'IEDR_CLASS_SCHOOL_EDUCATIONAL_INSTITUTION',
                    18 : 'IEDR_CLASS_SOLE_TRADER',
                    23 : 'IEDR_CLASS_STATUTORY_BODY',
                    27 : 'IEDR_CLASS_UNINCORPORATED_ASSOCIATION'
                   };

  var category_msgs = { 0 : 'IEDR_CATEGORY_CORPORATE_NAME',
                        1 : 'IEDR_CATEGORY_DISCRETIONARY_NAME',
                        2 : 'IEDR_CATEGORY_PUBLICATION_NAME',
                        3 : 'IEDR_CATEGORY_REGISTERED_BUSINESS_NAME',
                        4 : 'IEDR_CATEGORY_REGISTERED_TRADE_MARK_NAME',
                       11 : 'IEDR_CATEGORY_PERSONAL_NAME',
                       17 : 'IEDR_CATEGORY_SCHOOL_EDUCATIONAL_INSTITUTION_NAME',
                       26 : 'IEDR_CATEGORY_STATE_AGENCY_NAME',
                       31 : 'IEDR_CATEGORY_UNINCORPORATED_ASSOCIATION_NAME'
  }

  function class_category_onload(planPos_id, val) {
    var src_id = planPos_id + '[ClassCategory_Class]_' + split_condition[val][0];
    var dst_id = planPos_id + '[ClassCategory_Category]_' + split_condition[val][1];
    var src = document.getElementById(src_id)
    src.checked = true;
    document.getElementById(dst_id).checked = true;
    class_category_toggle(src);
  }

  function class_category_toggle(src) {
    var src_id = src.id;
    var src_nr = src_id.split(/_/).pop();
    var dst_id_general = src_id.replace(/ClassCategory_Class\]_\d+/, 'ClassCategory_Category]_');
    var checked_key = null;
    for (var dst_nr_key in dst_list) {
      var dst_nr = dst_list[dst_nr_key];
      var dst = document.getElementById(dst_id_general + dst_nr);
      if (dst_nr in merge_condition[src_nr]) {
        dst.disabled = false;
      } else dst.disabled = true;
      if (dst.checked) checked_key = dst_nr_key;
    }

    class_category_move_checked(dst_id_general, checked_key);
  }

  function class_category_move_checked(dst_id_general, checked_key) {
    var min_diff = dst_list.length;
    var new_checked_key = null;
    for (var i=0; i < dst_list.length; i++) {
      var dst = document.getElementById(dst_id_general + dst_list[i]);
      var diff = Math.abs(checked_key - i);
      if (!dst.disabled && diff < min_diff) {
        min_diff = diff;
        new_checked_key = i;
      }
    }

    if (new_checked_key != null) {
      var new_id = dst_id_general + dst_list[new_checked_key];
      document.getElementById(new_id).checked = true;
    }

    var id_general = dst_id_general.replace(/ClassCategory_Category\]_/, 'ClassCategory]');
    set_class_category(id_general);
  }

  function set_class_category(id_general) {
    var src_id_general = id_general.replace(/ClassCategory\]/, 'ClassCategory_Class]_');
    var dst_id_general = id_general.replace(/ClassCategory\]/, 'ClassCategory_Category]_');
    var src_msg_id = 'td__classMsg_' + id_general.substr(4).replace(/\[ClassCategory\]/, '');
    var dst_msg_id = 'td__categoryMsg_' + id_general.substr(4).replace(/\[ClassCategory\]/, '');

    var src_nr = 0;
    var dst_nr = 0;
    for (var i in merge_condition) {
      var src_id = src_id_general + i;
      if (document.getElementById(src_id).checked) {
        src_nr = i;
        break;
      }
    }
    for (var i=0; i<dst_list.length; i++) {
      dst_id = dst_id_general + dst_list[i];
      if (document.getElementById(dst_id).checked) {
        dst_nr = dst_list[i];
        break;
      }
    }

    var obj = document.getElementById(id_general);
    obj.value = merge_condition[src_nr][dst_nr];


    var _tmp = id_general.replace(/\[ClassCategory\]/, '');
    var tr_id_general = 'tr__' + _tmp.substr(4);

    if (src_nr == 0) provToggleTRDisplay(tr_id_general + '[CRN]', true);
    else provToggleTRDisplay(tr_id_general + '[CRN]', false);
    if (dst_nr == 3) provToggleTRDisplay(tr_id_general + '[RBN]', true);
    else provToggleTRDisplay(tr_id_general + '[RBN]', false);
    if (dst_nr == 4) provToggleTRDisplay(tr_id_general + '[TM]', true);
    else provToggleTRDisplay(tr_id_general + '[TM]', false);

    var src_msg = SW.DOM.byId(src_msg_id);
    var dst_msg = SW.DOM.byId(dst_msg_id);
    var class_msg_id = class_msgs[src_nr];
    var category_msg_id = category_msgs[dst_nr];

    src_msg.innerHTML = locale[class_msgs[src_nr]];
    dst_msg.innerHTML = locale[category_msgs[dst_nr]];
  }
{/literal}

//  end of domain_prov_iejs.tpl