<!--
  externalpay.tpl
-->

<script type="text/javascript" src="{$SCRIPT_DIR}/static/js/jquery.min.js"></script>

<script type="text/javascript" language="JavaScript">

  function ShowError(errorMessage) {
    document.getElementById("ErrorText").innerText = errorMessage;
    document.getElementById("Error").style.display = "block";
  }

  function submitForm(path, method, params) {
    var form = document.createElement("form");
    form.setAttribute("method", method);
    form.setAttribute("action", path);
    form.setAttribute("enctype", "application/x-www-form-urlencoded");
    form.style.display = "none";

    for (var key in params) {
      if (params.hasOwnProperty(key)) {
        var hiddenField = document.createElement("input");
        hiddenField.setAttribute("type", "hidden");
        hiddenField.setAttribute("name", key);
        hiddenField.setAttribute("value", params[key]);
        form.appendChild(hiddenField);
      }
    }
    document.documentElement.appendChild(form);
    form.submit();
  }

  function post(path, params) {
    submitForm(path, 'POST', params);
  }


  function PayByExternalPay() {
    {if $postData}
    document.getElementById("submit-redirect").submit();
    {else}
    window.location.href = "{$actionUrl}";
    {/if}
  }


  function redirect(redirectData) {
    if (redirectData.redirectMethod == 'POST') {
      submitForm(redirectData.redirectUrl, redirectData.redirectMethod, redirectData.redirectAttrs);
    } else if (redirectData.redirectUrl !== undefined) {
      var redirectUrl = redirectData.redirectUrl;

      if (redirectData.redirectAttrs) {
        submitForm(redirectData.redirectUrl, 'GET', redirectData.redirectAttrs);
        return;
      }

      console.debug(redirectUrl);
      window.location.href = redirectUrl;
    } else {
      if (redirectData.Message) {
        ShowError("{$smarty.session.LANG.REDIRECT_FAILED}: " + redirectData.Message);
      } else {
        ShowError("{$smarty.session.LANG.REDIRECT_FAILED} ");
      }
    }
  }

  function onETransactionResponse(response) {
    try {
      var etransactionData = JSON.parse(response);
      if (etransactionData.error) {
        window.open('','_parent','');
        window.close();
      } else {
        redirect(etransactionData);
      }
    } catch(e) {
      ShowError(e.messageText);
    }
  }

  function eTransactionPay(docID) {
    $.post( '?info=etransactionpay', { "DocID" : docID }, onETransactionResponse );
  }

  var counter = 0;
  function checkOrderPlacement() {
    $.get('?info=checkorderplacement', function(data) {
       try {
         var response = JSON.parse(data);
         if (response.placed && response.DocID) {

           if (response.redirectInfo) {
             redirect(response.redirectInfo);
           } else {
             eTransactionPay(response.DocID);
           }

         } else if (response.error) {
           window.open('','_parent','');
           window.close();
         } else {
           setTimeout(checkOrderPlacement, 500 + counter++ * 500);
         }
       } catch(e) {
         ShowError(e.messageText);
       }
    });
  }

  window.onload = function() {
    {if $actionUrl}
    PayByExternalPay();
    {else}
    setTimeout(checkOrderPlacement, 10);
    {/if}
  }

</script>

{if $postData}
<form id="submit-redirect" method="{$redirectMethod}" action="{$actionUrl}" style="display:none;">
  {foreach item=value key=param from=$postData}
  <input type="hidden" name="{$param}" value="{$value}"/>
  {/foreach}
</form>
{/if}


<div id="Error" style="display: none;">
  <table class="Error" cellpadding="0" cellspacing="0" style="width: 100%;">
    <tr>
      <td class="ErrorTD">

        <table class="tableContent tableErrorContent" cellpadding="0" cellspacing="0">
          <tr>
            <td class="tableContentTD tableErrorContentTD ErrorText">
              <ul>
                <li id="ErrorText"></li>
              </ul>
            </td>
          </tr>
        </table>

        <table class="tableFooter tableErrorFooter" cellpadding="0" cellspacing="0">
          <tr>
            <td class="tableFooterTD tableErrorFooterTD">&nbsp;</td>
          </tr>
        </table>

      </td>
    </tr>
  </table>
</div>

<h4>{$smarty.session.LANG.REDIRECT_TEXT} <a href="#" OnClick="PayByExternalPay(); return false;">{$smarty.session.LANG.BUTTON_PAY_EXTERNAL}</a></h4><br/>


<!--
  end of externalpay.tpl
-->

