<!--
  aps_step.tpl
-->

<div id="aps-step-template">

    <div id="aps-step-title" class="tableOrderHeaderWrapper" style="display: none;">
        <table class="tableHeader tableOrderHeader" cellspacing="0" cellpadding="0">
            <tbody>
            <tr>
                <td class="tableHeaderTD">
                    <span id="aps-step-title-text" class="BlockName BlockNameOrder"></span>
                </td>
            </tr>
            </tbody>
        </table>
    </div>

    <style>
        @import url(/static/design/css/wizard/aps-wizard.css);
    </style>

    <!-- APS UI content -->
    <table class="tableContent tableOrderContent" cellpadding="0" cellspacing="0">
        <tbody>
        <tr>
            <td class="tableContentTD tableOrderContentTD" align="center">
                <div id="aps-container">
                    <div id="ccp-content" class="hidden-spin">
                        <div class="ccp-content-header" style="display: none">
                            <h1 id="ccp-title">
                                <small class="pull-right hidden-xs" id="legacy-items"></small>
                                <small id="ccp-breadcrumb" style="display: none"></small>
                                <span></span>
                                <small id="ccp-title-hint"></small>
                                <small id="ccp-view-description"></small>
                            </h1>
                            <div id="ccp-messages">
                                <div class="apsMessageList" widgetid="msList" id="msList" style="display: none;"></div>
                            </div>
                        </div>

                        <div class="loading-spin">&#xf021;</div>

                        <div id="aps2MashupArea">
                            <!-- IFrames placeholder -->
                        </div>

                        {ApsSendRequest
                            assign='apsNavigationTree'
                            method='POST' uri='/navigation'
                            body='{"placeholder": "http://odin.com/ui/online-store", "viewId": "'|cat:$viewId|cat:'"}'
                            token=$serviceTemplateToken}

                        {if $userToken}
                            {ApsSendRequest
                                assign='apsAccounts'
                                asObject=true
                                method='GET' uri='/resources?implementing(http://aps-standard.org/types/core/account/1.0)'
                                token=$userToken}

                            {if count($apsAccounts)}
                                {assign var='accountApsId' value=$apsAccounts[0]->aps->id}

                                {ApsSendRequest
                                    assign='apsAccount'
                                    method='GET' uri='/resources/'|cat:$accountApsId
                                    token=$userToken}

                                {ApsSendRequest
                                    assign='apsUsers'
                                    method='GET' uri='/resources/'|cat:$accountApsId|cat:'/users'
                                    token=$userToken}

                                {ApsSendRequest
                                    assign='apsBrands'
                                    method='GET' uri='/resources/'|cat:$accountApsId|cat:'/brands'
                                    token=$userToken}
                            {/if}
                        {/if}

                        <script>
                            {literal}
                            var aps = window.aps || {};

                            if (window.history.pushState) {
                                History.prototype.pushState = function (state, title, newUrl) {
                                    // Protect current location
                                    newUrl = window.location.href;
                                    window.history.replaceState(state, title, newUrl);
                                };
                            }

                            function decode(val) {
                                if (typeof val === "string") return val.replace(/&lt;/ig, "<").replace(/&gt;/ig, ">").replace(/&quot;/ig, '"');
                                if (typeof val === "object") {
                                    for (var prop in val) val[prop] = decode(val[prop]);
                                }
                                return val;
                            }

                            aps.version = '{/literal}{$apsVersion}{literal}';
                            aps.context = {};
                            aps.placeholder = '{/literal}{$placeholderId}{literal}';
                            aps.navigation = {};
                            aps.navigation.tree = decode({/literal}{$apsNavigationTree}{literal});

                            // Initialize storage for bizAPI
                            aps.bizStorage = {
                                resourcesToBind: {
                                    account: decode({/literal}{$apsAccount}{literal}),
                                    users: decode({/literal}{$apsUsers}{literal}),
                                    brands: decode({/literal}{$apsBrands}{literal})
                                }
                            };

                            // Initialize storage for OnlineStore
                            aps.onlineStore = {apsDefaults: {}};
                            {/literal}

                            {if $apsDefaults}
                                aps.onlineStore.apsDefaults = {$apsDefaults};
                            {/if}
                        </script>

                        <script src="/aps/2/ui/runtime/client/aps/aps.debug.js?version={$apsVersion}"></script>
                        <script src="/aps/2/ui/runtime/host/hostLayer.debug.js?version={$apsVersion}"></script>
                        <script src="/static/js/aps/host/touchSession.js?version={$apsVersion}"></script>
                        <script src="/static/js/aps/host/notification.js?version={$apsVersion}"></script>
                        <script src="/static/js/aps/host/bizStorageAction.js?version={$apsVersion}"></script>

                        <script>
                            {literal}

                            require([
                                'aps/common',
                                'host/host',
                                'aps/ready!'
                            ], function (common, host) {
                                aps = window.aps || {};

                                $('#aps-step-title-text').text(aps.navigation.tree.context[0].viewLabel);
                                $('#aps-step-title').css('display', '');

                                var replaceBizViewPlugin = function (node) {
                                    if ('object' != typeof(node)) {
                                        return;
                                    }
                                    common.forEach(node, function (children) {
                                        replaceBizViewPlugin(children);

                                        if ('view-plugin' == children.type
                                            && 'http://www.parallels.com/ccp-billing#bizApiPlugin' == children.id)
                                        {
                                            children.src = '/static/js/aps/plugin/bizAPI.js';
                                        }
                                    });
                                };

                                replaceBizViewPlugin(aps.navigation.tree);

                                host({
                                    context: {
                                        bs: true,
                                        visibleMode: 'md',
                                        passwordQualityLevel: 1,

                                        wizardData: decode(
                                            {/literal}{if null !== $wizardData}
                                            {$wizardData}
                                            {else}
                                                {literal}{'{/literal}{$viewId}{literal}': null}{/literal}
                                            {/if}{literal}
                                        ),

                                        _css: ['{/literal}{$viewCssPath}?{$apsVersion}{literal}'],
                                        _token: '{/literal}{if $userToken}{$userToken}{else}{$serviceTemplateToken}{/if}{literal}',
                                        _locale: '{/literal}{msg what="APS_UI_LANGUAGE_ID" default="en_US"}{literal}',
                                        _devMode: false
                                    }
                                }, undefined);

                                /**
                                 * Buttons handlers
                                 */
                                var goto = function (navigation, wizardData, apsDefaults) {
                                    var form = $('#navigation')[0];

                                    if (wizardData) {
                                        AddHiddenFields(form, 'wizardData', JSON.stringify(wizardData));
                                    }
                                    if (apsDefaults) {
                                        AddHiddenFields(form, 'apsDefaults', JSON.stringify(apsDefaults));
                                    }
                                    AddHiddenFields(form, 'navigation', navigation);

                                    form.submit();
                                };

                                $('#prevButton').each(function (i, button) {
                                    button.onclick = function () {
                                        setDisableForButtons(true);
                                        aps.app.onPrev();
                                    };
                                });
                                $('#nextButton').each(function (i, button) {
                                    button.onclick = function () {
                                        setDisableForButtons(true);
                                        aps.app.onNext();
                                    };
                                });
                                $('#cancelButton').each(function (i, button) {
                                    button.onclick = function () {
                                        setDisableForButtons(true);
                                        aps.app.onCancel();
                                        goto('cancel');
                                    };
                                });

                                function putParamsToWizard(params) {
                                    if (params) {
                                        aps.context.wizardData['{/literal}{$viewId}{literal}'] = params;
                                    }
                                }

                                aps.apsc.prev = function (params) {
                                    putParamsToWizard(params);
                                    goto('prior', aps.context.wizardData, aps.onlineStore.apsDefaults);
                                };
                                aps.apsc.next = function (params) {
                                    putParamsToWizard(params);
                                    goto('next', aps.context.wizardData, aps.onlineStore.apsDefaults);
                                };

                                function setDisableForButtons(isDisabled) {
                                    $('[type=button]').each(function (i, button) {
                                        SW.Button.setDisabled(button, isDisabled);
                                    });
                                }

                                aps.apsc.originalHideLoading = aps.apsc.hideLoading;
                                aps.apsc.hideLoading = function () {
                                    setDisableForButtons(false);
                                    aps.apsc.originalHideLoading();
                                };

                                aps.apsc.originalCancelProcessing = aps.apsc.cancelProcessing;
                                aps.apsc.cancelProcessing = function () {
                                    setDisableForButtons(false);
                                    aps.apsc.originalCancelProcessing();
                                };
                            });
                            {/literal}
                        </script>
                    </div>
                </div>
            </td>
        </tr>
        </tbody>
    </table>

    <!-- Buttons group -->
    <form method="post" id="navigation">
        {GetCSRFTokenElement}

        <table class="tableFooter" cellpadding="0" cellspacing="0">
            <tr>
                <td class="tableFooterTD">

                    <table cellpadding="0" cellspacing="0" style="width:100%;">
                        <tr>
                            <td style="width:50%;" align="left">
                                <button type="button" class="buttonCancel SWbutton_Disable" id="cancelButton"
                                        disabled>{$smarty.session.LANG.LABEL_CANCEL}</button>
                            </td>
                            <td style="width:50%;" align="right">
                                {if $showPriorButton}
                                    <button type="button" class="buttonBack SWbutton_Disable" id="prevButton"
                                            disabled>{$smarty.session.LANG.BUTTON_BACK}</button>
                                {/if}
                                <button type="button" class="buttonContinue SWbutton_Disable" id="nextButton"
                                        disabled>{$smarty.session.LANG.LABEL_CONTINUE}</button>
                            </td>
                        </tr>
                    </table>

                </td>
            </tr>
        </table>

    </form>
</div>

<!--
  end of aps_step.tpl
-->
