<!-- paci_vps_options_js.tpl -->

<script type="text/javascript">
	var pbaResources = {$plan.PlanRate|@json_encode}; // [LB] PBA resource rates
	//var provParams = {$prov|@json_encode};
	var token = '{$token}';
	var veConfig = {$state->aps_json};

	{literal}	
	var sample;
	var pbaResourcesById = {};
	var pbaResourcesByName = {};
	var pbaResourcesByApsType = {};
	var osByApsId = {};
	var pleskPanel = {};

	// Map of resource types where key is a short name of a type (w/o version included) and
    // value is a full name of the appropriated resource's type.
	var resourceTypes = {
	{/literal}
        {GetApsResourceTypes assign='resources' packageId='http://www.parallels.com/products/poa/cloud/infrastructure'}
        {foreach $resources as $shortName => $fullName}
            '{$shortName}': '{$fullName}'{if $fullName@last}{else}{",\n"}{/if}
        {/foreach}
    {literal}
    };

	function findResourceIdByType(resources, type) {
		for (idx in resources) {
			if (('aps' in resources[idx]) && (resources[idx].aps.type === type)) {
				return resources[idx].aps.id;
			}
		}
		return null;
	}
	function findResourceById(resources, id) {
		for (idx in resources) {
			if (('aps' in resources[idx]) && (resources[idx].aps.id === id)) {
				return resources[idx];
			}
		}
		return null;
	}
	var uomMultipliers = [
		{"uom": ["kb", "mb", "gb"], "multiplier": 1024},
		{"uom": ["khz", "mhz", "ghz"], "multiplier": 1000},
		{"uom": ["kbit/s", "mhz", "ghz"], "multiplier": 1000}
	]
	function convertUnits(value, fromUOM, toUOM){
		//console.log("converting " + value + " " +fromUOM+ " to " + toUOM);
		//console.log("toUOM " + toUOM);
		fromUOM = fromUOM.toLowerCase();
		toUOM = toUOM.toLowerCase();
        if(fromUOM === toUOM){
            return value;
        }
		for(indx in uomMultipliers){
			fromUOMIndx = uomMultipliers[indx].uom.indexOf(fromUOM);
			toUOMIndx = uomMultipliers[indx].uom.indexOf(toUOM);
            if(fromUOMIndx != -1 && toUOMIndx!=-1){
                var mult = Math.pow(uomMultipliers[indx].multiplier, (fromUOMIndx - toUOMIndx));
                var res = value*mult;
				//console.log("result: " + res);
                return res;
            }
		}
        console.error("cannot convert " + fromUOM + " to " + toUOM);
	}
	function prepareSample(sample) {
		function prepareHwLimits(hwProperty, name, unitInSample){
			var pbaRes = pbaResourcesByName[name];
			if (pbaRes) {
				hwProperty.value = convertUnits(hwProperty.value, unitInSample, pbaRes.UOM_ID);
				hwProperty.max = convertUnits(hwProperty.max, unitInSample, pbaRes.UOM_ID);
				hwProperty.step = convertUnits(hwProperty.step, unitInSample, pbaRes.UOM_ID);
				hwProperty.uom = pbaRes.UnitOfMeasure;
			}
		}
		prepareHwLimits(sample.hardware.memory, "ram", "mb");
		prepareHwLimits(sample.hardware.disk.space, sample.hardware.disk.storage == "local" ? "hdd" : "hdd2", "gb");
		prepareHwLimits(sample.hardware.cpu.power, "power", "mhz");
	}
	function loadOsTemplates(){
		var deferred = jQuery.Deferred();
		var requests = [];

		requests.push(jQuery.ajax({
			url: "/aps/2/resources/" + sample.aps.id + "/os",
			headers: {'APS-Token' : token}
		}));

		jQuery.when.apply($, requests).done(function (oses){
			//var oses = JSON.parse(result);
			for(var i=0; i < oses.length; i++){
				osByApsId[oses[i].aps.id] = oses[i];
			}
			deferred.resolve();
		}).fail(function(error){
			console.error("Cannot load OS templates. Make sure PACI service is running");
		});
		return deferred;
	}

    function preparePleskPanel(limits) {
        var pleskConf = [];
        for ( idx in limits ) {
            var limit = limits[idx];
            if (limit.apsType && limit.apsType.indexOf("http://www.parallels.com/aps/plesk/configuration/") >= 0)
                pleskConf.push(limit);
        }

        jQuery.map(pbaResourcesById, function (pbaResourceById) {
            if ( pbaResourceById.IncludedInComposite != "") {
              var simpleResList = pbaResourceById.IncludedInComposite.split(';');
              for ( idx in pleskConf ) {
                  if ( jQuery.inArray(String( pleskConf[idx].id ), simpleResList) > -1 )
                      pleskPanel[pbaResourceById.ID] = pbaResourceById;
              }
            }
        });
    }

	function prepareResources() {
	    var deferred = jQuery.Deferred();
	    var pbaResourcesByResourceId = {};
		var resourceIdByApsResourceId = {};

	    jQuery.map(pbaResources, function (pbaResource) {
	        pbaResourcesByResourceId[pbaResource.ResourceID] = pbaResource;
	    });
		jQuery.map(pbaResources, function (pbaResource) {
	        pbaResourcesById[pbaResource.ID] = pbaResource;
	    });

        {/literal}
        var rootApsRes = {ApsSendRequest method='GET' uri='/resources' token=$token};
        {literal}

        var serviceTemplateId = findResourceIdByType(rootApsRes, 'http://parallels.com/aps/types/pa/serviceTemplate/1.1');
        if (serviceTemplateId == null) {
            console.error("Service Template not found in APS resources");
            return false;
        }
        // from "limits" we get PA resource ID's
        jQuery.ajax({
            url : "/aps/2/resources/" + serviceTemplateId + "/limits",
            headers : {
                'APS-Token' : token
            }
        }).done(function (limits) {
            jQuery.map(limits, function(limit){
                resourceIdByApsResourceId[limit.apsId] = limit.id;
                if('property' in limit){
                    pbaResourcesByName[limit.property] = pbaResourcesByResourceId[limit.id];
                }
                pbaResourcesByApsType[limit.apsType] = pbaResourcesByResourceId[limit.id];
                if (limit.apsType && limit.apsType.indexOf("http://www.parallels.com/infrastructure/virtual-environment/sample/") === 0) {
                    sample = findResourceById(rootApsRes, limit.apsId);
                }
            });
            if (sample == null) {
                console.error("Sample not found in APS resources");
                return false;
            }
            prepareSample(sample);
            preparePleskPanel(limits);
            loadOsTemplates().done(function(){
                deferred.resolve();
            });
        });

	    return deferred;
	}
	jQuery( document ).ready(function() {
		prepareResources().done(function(){
			var pbaRes;
			var rowIndex = 0;
			updateTotalPrice();
			// Hardware
			pbaRes = pbaResourcesByName['cpu'];
            if ( pbaRes ) {
			  var cpuSlider = jQuery('#sliderTmpl').tmpl({
					id : 'cpu_number',
					pbaRes: pbaRes,
					step: sample.hardware.cpu.number.step,
					indx: rowIndex ++,
					label : (pbaRes.StoreText !='')? pbaRes.StoreText: pbaRes.Name
				}).insertBefore('#additional');
            }
			pbaRes = pbaResourcesByName['ram'];
            if ( pbaRes ) {
                jQuery('#sliderTmpl').tmpl({
					id : 'memory',
					step: sample.hardware.memory.step,
					indx: rowIndex ++,
					pbaRes : pbaRes,
					label : (pbaRes.StoreText !='')? pbaRes.StoreText: pbaRes.Name
				}).insertBefore('#additional');
            }
			pbaRes = pbaResourcesByName['hdd'] ? pbaResourcesByName['hdd'] : pbaResourcesByName['hdd2'];
            if ( pbaRes ) {
				jQuery('#sliderTmpl').tmpl({
					id : 'disk_space',
					step: sample.hardware.disk.space.step,
					indx: rowIndex ++,
					pbaRes : pbaRes,
					label : (pbaRes.StoreText !='')? pbaRes.StoreText: pbaRes.Name
				}).insertBefore('#additional');
            }
			pbaRes = pbaResourcesByName['bandwidth'];
            if ( pbaRes ) {
				jQuery('#sliderTmpl').tmpl({
					id : 'bandwidth',
					step: sample.hardware.bandwidth.step,
					indx: rowIndex ++,
					pbaRes: pbaRes,
					label : (pbaRes.StoreText !='')? pbaRes.StoreText: pbaRes.Name
				}).insertBefore('#additional');
            }

			function needToShow(pbaRes){
				return (pbaRes && (Number(pbaRes.IncludedValue) < Number(pbaRes.UpperLimit) || 
						(Number(pbaRes.UpperLimit) == -1 && Number(pbaRes.IncludedValue) != -1)));
			}
			function initialValue(pbaRes){
				return ('Amount' in pbaRes) ? Number(pbaRes.Amount) + Number(pbaRes.IncludedValue) : pbaRes.IncludedValue;
			}
			var sliderIds = [];
			pbaRes = pbaResourcesByApsType[resourceTypes['http://www.parallels.com/infrastructure/virtual-environment/ip-v4-address']];
			if(needToShow(pbaRes)){
				jQuery('#numberFieldTmpl').tmpl({
					id : 'ipv4',
					pbaRes: pbaRes,
					value: initialValue(pbaRes),
					label : (pbaRes.StoreText !='')? pbaRes.StoreText: pbaRes.Name,
					type: "spin"
				}).insertBefore('#total');
				sliderIds.push('ipv4');
			}
			pbaRes = pbaResourcesByApsType[resourceTypes['http://www.parallels.com/infrastructure/virtual-environment/ip-v6-address']];
			if(needToShow(pbaRes)){
				jQuery('#numberFieldTmpl').tmpl({
					id : 'ipv6',
					pbaRes: pbaRes,
					value: initialValue(pbaRes),
					label : (pbaRes.StoreText !='')? pbaRes.StoreText: pbaRes.Name,
					type: "spin"
				}).insertBefore('#total');
				sliderIds.push('ipv6');
			}
			pbaRes = pbaResourcesByName['inboundTraffic'];
			if(needToShow(pbaRes)){
				jQuery('#numberFieldTmpl').tmpl({
					id : 'traffic_in',
					pbaRes: pbaRes,
					value: initialValue(pbaRes),
					label : (pbaRes.StoreText !='')? pbaRes.StoreText: pbaRes.Name,
					type: "spin"
				}).insertBefore('#total');
				sliderIds.push('traffic_in');
			}
			pbaRes = pbaResourcesByName['outboundTraffic'];
			if(needToShow(pbaRes)){
				jQuery('#numberFieldTmpl').tmpl({
					id : 'traffic_out',
					pbaRes: pbaRes,
					value: initialValue(pbaRes),
					label : (pbaRes.StoreText !='')? pbaRes.StoreText: pbaRes.Name,
					type: "spin"
				}).insertBefore('#total');
				sliderIds.push('traffic_out');
			}
			pbaRes = pbaResourcesByName['backupSpace'];
			if(needToShow(pbaRes)){
				jQuery('#numberFieldTmpl').tmpl({
					id : 'backup_space',
					pbaRes: pbaRes,
					value: initialValue(pbaRes),
					label : (pbaRes.StoreText !='')? pbaRes.StoreText: pbaRes.Name,
					type: "spin"
				}).insertBefore('#total');
				sliderIds.push('backup_space');
			}
			pbaRes = pbaResourcesByName['imageSpace'];
			if(needToShow(pbaRes)){
				jQuery('#numberFieldTmpl').tmpl({
					id : 'image_space',
					pbaRes: pbaRes,
					value: initialValue(pbaRes),
					label : (pbaRes.StoreText !='')? pbaRes.StoreText: pbaRes.Name,
					type: "spin"
				}).insertBefore('#total');
				sliderIds.push('image_space');
			}
			populateOsList();
            populatePleskPanel();
			restoreState();
			jQuery('.fieldsArea').show();
			//make spinners
			sliderIds.map(function(id){
				SW.Widget.Spin.convert(document.getElementById(id));
			});
			//make table look zebra
			jQuery('#resourcesTable > tbody > tr.generalRow:visible').each(function(index, row){
				if(index%2 == 0){
					jQuery(row).addClass("oddRowTable");
				}
			});
			jQuery('#resourcesTable > tbody > tr.additionalRow:visible').each(function(index, row){
				if(index%2 == 0){
					jQuery(row).addClass("oddRowTable");
				}
			});

            if ( jQuery('#resourcesTable > tbody > tr.generalRow:visible').length == 0 ) {
                jQuery('#general').hide();
                jQuery('#generalheader').hide();
            }
            if ( jQuery('#resourcesTable > tbody > tr.additionalRow:visible').length == 0 ) {
                jQuery('#additional').hide();
                jQuery('#additionalheader').hide();
            }
			jQuery('#loading').hide();
		});
		jQuery("#hostname").keyup(function() {
			validateHostname();
		});
	});
	function restoreState(){
		if('hostname' in veConfig){
			jQuery('#hostname').val(veConfig.hostname);
		}
	}
	function calcLimits(sampleLimits, pbaRes){
		return {
			min : sampleLimits.value,
			max : (pbaRes!=null && pbaRes.UpperLimit!=-1) ? Math.min(sampleLimits.max, pbaRes.UpperLimit) : sampleLimits.max
		}
	}
	function populateOsList(){		
		var osIds = sample.templates.os;
        var winos = false, linos = false;
		for(idx in osIds){
            if (!osByApsId[osIds[idx]]) continue;
            var divID;
            var ostype = osByApsId[osIds[idx]].osType.toLowerCase();
            if (ostype.indexOf('linux') != -1) {
                linos = true;
                divID = '#ossTable';
            } else {
                winos = true;
                divID = '#winTable';
            }
			jQuery('#radioButtonTmpl').tmpl({id: osIds[idx], label: osByApsId[osIds[idx]].readableName, name: "oss", fee: 0}).appendTo(divID);
		}
		var selected = ('osId' in veConfig) ? veConfig.osId : sample.templates.defaultOS;
		jQuery('#' + selected).prop('checked', true);
		if (jQuery('#ossTable tr').length + jQuery('#winTable tr').length < 2 ) jQuery('#osblock').hide();
		else if ( !linos ) jQuery('#linTd,#linHeader').hide();
		else if ( !winos ) jQuery('#winTd,#winHeader').hide();

	}

    function populatePleskPanel() {
        var cur_id, cur_name = "pleskPanel", cur_label, cur_textprice, fee;
        var pleskInclude = false;
        for(idx in pleskPanel){
            cur_id = pleskPanel[idx].ID;
            cur_label = pleskPanel[idx].Name;
            cur_textprice = locale["CURRENCY_PREFIX"] + pleskPanel[idx].RecurringFee + locale["CURRENCY_POSTFIX"];
            cur_textprice += month;
            fee = pleskPanel[idx].RecurringFee;
            jQuery('#radioButtonTmpl').tmpl({id: cur_id, label: cur_label, name: cur_name, textprice: cur_textprice, fee: fee}).appendTo('#pleskTable');
            if ( pleskPanel[idx].Amount == 1) {
                jQuery('#' + cur_id).prop('checked', true);
                jQuery('#price_pleskPanel').attr("price", fee);
                updateTotalPrice();
            }
            if (pleskPanel[idx].IncludedValue > 0) pleskInclude = true;
        }

        if ( jQuery('#pleskTable tr').length < 2 || pleskInclude) jQuery('#pleskblock').hide();

    }

    function calcPriceRadio(obj) {
        var price_obj_name = "price_" + obj.name;
        var fee = obj.attributes['fee'].value;
        jQuery('#' + price_obj_name).attr("price", fee);

        updateTotalPrice();
        if (obj.name === "oss")
        	validateHostname();
    }

	function updateTotalPrice(){
		var total = Number(cloud_base_price_month);
		jQuery('[price]').map(function(){
			total += Number(jQuery(this).attr("price"));
		});
		cloudUpdatePrice('cloud_total_month', total);
	}
	function onParamChanged(e, name){
		//console.log('onParamChanged(' + name + ')');
		var control = jQuery('#' + name);
		var amount = Number(control.val());
		var included = Number(control.attr('included'));
		var limit = Number(control.attr('limit'));
		if(amount < included) {
			control.val(included);
			return;
		}
		if(limit != -1 && amount > limit) {
			control.val(limit);
			return;
		}
		var fee = Number(control.attr('fee'));
		if(fee) {
			cloudUpdatePrice('price_'+name, (amount-included)*fee);
			updateTotalPrice();
		}
	}
	function onSubmitForm() {
		if (jQuery('#chooseVirtualServer_buttonContinue').attr("disabled"))
			return false;
	    prepareVeConfig();

	    jQuery('[pbaresid]').map(function () {
	        var resId = jQuery(this).attr("pbaresid");
	        var additional = Number(jQuery(this).val()) - Number(jQuery(this).attr("included"));
	        $('<input>').attr({
	            type : 'hidden',
	            name : resId
	        }).val(additional).appendTo('form');
		if ( jQuery(this).attr("id").indexOf('cpu_number') != -1 ) { 
			pbaResPower = pbaResourcesByName['power'];
            // support legacy "VPS CPU Power"
            if(pbaResPower) {
                var core_power = Number(pbaResPower.IncludedValue) / Number(jQuery(this).attr("included"));
                var power_val = core_power * ( Number(jQuery(this).val()) -  Number(jQuery(this).attr("included")) );
                $('<input>').attr({
                    type : 'hidden',
                    name : pbaResPower.ID
                }).val(power_val).appendTo('form');
            }
		}
	    });
	    return true;
	}
	function prepareVeConfig() {

	    var provisioningParams = {
	        "aps" : {
	            "type" : resourceTypes["http://www.parallels.com/infrastructure/virtual-environment"]
	        },
	        "name" : jQuery('#hostname').val(),
	        "hostname" : jQuery('#hostname').val(),
			"osId" : jQuery('input:radio[name=oss]:checked').val()
        };
	    jQuery('#aps_json').val(JSON.stringify(provisioningParams));
	}
	function validateHostname() {
		var hostname = jQuery('#hostname').val();
		var isCommonValid = true, isWinValid = true;
		if (hostname !== "") {
			var winDottedRegex = new RegExp(/^[a-zA-Z][a-zA-Z0-9\\-]{0,13}[a-zA-Z0-9]$/);
			var commonDottedRegex = new RegExp(/^[a-zA-Z0-9]([a-zA-Z0-9\\-]{0,61}[a-zA-Z0-9])?$/);
			if (jQuery('#winTd input').is(':checked'))
				isWinValid = winDottedRegex.test(hostname);
			else
				isCommonValid = commonDottedRegex.test(hostname);	
		}
		jQuery("#error__CommonHost").toggleClass("widgetHidden", isCommonValid);
		jQuery("#error__WinHost").toggleClass("widgetHidden", isWinValid);
		if (isCommonValid && isWinValid)
			enableContinue();
		else
			disableContinue()
	}
	function disableContinue() {
		var $button = jQuery('#chooseVirtualServer_buttonContinue');
		$button.attr('disabled', true);
		$button.toggleClass("SWbutton_Disable", true);
	}
	function enableContinue() {
		var $button = jQuery('#chooseVirtualServer_buttonContinue');
		$button.removeAttr("disabled");
		$button.toggleClass("SWbutton_Disable", false);
	}
	{/literal}
</script>
<!-- end of paci_vps_options_js.tpl -->

